
var inventory = angular.module('inventory', []);

inventory.service("inventorysvc", function() {
	this.nodeToObject =  function(node_id) {
		var obj = {
			system_id: null,
			client_id: null,
			app_id: null,
			host_guid: null,
			instance_id: null
		};
		// id components are "_" delimited, e.g.,
		//
		// system-id_client-id_app-id_instance-id
		// system-id_client-id_app-id_host-guid_instance-id
		// system-id_client-id
		//
		var a = node_id.split("_");
		if (a.length > 0) {
			obj.system_id = a[0];
		}
		if (a.length > 1) {
			obj.client_id = a[1];
		}
		if (a.length > 2) {
			obj.app_id = a[2];
		}
		if (a.length > 3) {
			if (a.length > 4) {
				obj.host_guid = a[3];
				obj.instance_id = a[4];
			} else {
				obj.instance_id = a[3];
			}
		}
		return obj;
	}
    this.getAssetType = function(app_id){
    if(app_id === APP_ID_FILE_LEVEL){
        /*if(joborder.clients[0].name.indexOf("-NAS-RRC")>-1){ //hack till backend fix it.
        return INVENTORY_TYPE_FAMILY_CLIENT_NAS;
        }*/
        return INVENTORY_TYPE_FAMILY_CLIENT;
    } else if(app_id === APP_ID_VMWARE){
        return INVENTORY_TYPE_FAMILY_VMWARE;
    } else if(app_id === APP_ID_HYPERV_2008_R2 || app_id === APP_ID_HYPERV_2012){
        return INVENTORY_TYPE_FAMILY_HYPER_V;
    } else if (app_id === APP_ID_EXCHANGE_2003 || app_id === APP_ID_EXCHANGE_2007 || app_id === APP_ID_EXCHANGE_2010 || app_id === APP_ID_EXCHANGE_2013) {
        return INVENTORY_TYPE_FAMILY_EXCHANGE;
    }else if (app_id === APP_ID_SQL_SERVER_2005 || app_id === APP_ID_SQL_SERVER_2008 || app_id === APP_ID_SQL_SERVER_2008_R2 
    || app_id === APP_ID_SQL_SERVER_2012 || app_id === APP_ID_SQL_SERVER_2014) {
        return INVENTORY_TYPE_FAMILY_SQL;
    }else if (app_id === APP_ID_SHAREPOINT_2007 || app_id === APP_ID_SHAREPOINT_2010 || app_id === APP_ID_SHAREPOINT_2013) {
        return INVENTORY_TYPE_FAMILY_SHAREPOINT;
    }else if (app_id === APP_ID_ORACLE_11 || app_id === APP_ID_ORACLE_12 || app_id === APP_ID_ORACLE_10) {
        return INVENTORY_TYPE_FAMILY_ORACLE;
    }
    }
});