angular.module('backupCopyOptionDialogModule', ['ngDialog'])
.controller('BackupCopyOptionDialogController', ['$scope', '$rootScope', '$http','ngDialog', function($scope, $rootScope, $http,ngDialog) {
    
    $scope.applianceObject = $("[ng-controller=AppliancesCtrl]").scope(); 
    $scope.applianceStorageArr=[];
    $scope.formName = {}
    $scope.strApprovalDeniedMessage= "";
    
    $http({
        method: 'GET',
        url: '/api/storage/?sid=1&usage=backup' 
    }).success(function(data, status, headers) {
        if (data && data.storage) {
            $scope.applianceStorageArr = data.storage;
        }
    }); 
    
    $scope.init = function () {
        $scope.backupCopySelection; 
        $scope.selectionchangeflag = false;
        $scope.isStorageShow = false;
    }

    $scope.onBackupCopyOptionChange=function(){
        $scope.selectionchangeflag =true;
    }
    
    $scope.replicationPendingApproval = function(){
        var parameters = {};
        var arguments={};
        var request_id = 0;
        var url = "/api/replication/source/";
        
        
        
        if($scope.backupCopySelection == 'notapproval'){
            if($scope.formName.backupCopyOptionForm.approval_Denied_Message.$invalid){
                return;
            }
            
            arguments.accept = false;
            arguments.request_id = $scope.selectedPendingSource.request_id;
            arguments.message = $scope.strApprovalDeniedMessage;

        }else{
            if($scope.formName.backupCopyOptionForm.backup_copy_selectstorage.$invalid){
                return;
            }
            
            arguments.accept = true;
            arguments.request_id = $scope.selectedPendingSource.request_id;
            arguments.storage_id = $scope.applianceStorageArr.name.id;
        }

        
         $http({
            method: 'POST',
            params:parameters,
            url :url,
            data: JSON.stringify( arguments)
        }).success(function(data, status, headers){
             if($scope.backupCopySelection == 'notapproval'){
                ngDialog.open({
                    dialogType:'Information',
                    dialogMessage:"Backup copies from this appliance have been rejected."
                })
             }else{
                ngDialog.open({
                    dialogType:'Information',
                    dialogMessage:"Backup Copies from this appliance have been approved."
                })
             }
        }).error(function(response) { 
             ngDialog.open({
             dialogType:'retry',
             modelDialogId:'replication-source-approval-dailog',
             dialogMessage:response.result[0].message
            })
        });

    };
    
}]);