(function($, PHD, window, undefined) {
    var $form = $("#users-edit-form"),
        allUsers,
        UsersTable,
        $usersTable,
        UsersForm,
        $btnAddUser = $(".users-add"),
        $btnEditUser = $(".users-edit"),
        $btnDeleteUser = $(".users-delete"),
        $btnSaveUser = $(".users-save"),
        $btnCancel = $(".users-cancel"),
        roleSelect,
        $roleSelect = $("#role"),
        EditUser = false,
        UsersRowData,id,username,superuser,customers = {},locations = {},systems = {},
        multiple,common_privilege_level;


    function initForm() {

        $btnAddUser.on("click", function(event) {
            EditUser = false;
            $("#box_title").text("Add User");
            $("#passwordLabel1").text("Password");
            $("#confirm_password").show();
            $("#password1").show();
            $("#change_password").hide();
            $("#currentPassword").hide();
            $("#username").val("");
            $("#password1").val("");
            $("#password2").val("");
            handleAddUser();
        });
        $btnCancel.on("click", handleAddUser);
        $btnSaveUser.on("click", handleSaveUser);
        $btnEditUser.on("click", function(event) {
            EditUser = true;
            $("#box_title").text("Edit User");
            $("#confirm_password").hide();
            $("#password1").hide();
            $("#change_password").show();
            $("#username").val(username);
            if(typeof id !== "undefined"){
                if(superuser){
                    $roleSelect.val(4);
                    handleAddUser();
                }
                else if(multiple){
                    PHD.alert("Please use Legacy UI to update this user information.");
                }
                else{
                    $roleSelect.val(common_privilege_level);
                    handleAddUser();
                }
            }
            else{
                PHD.alert("You must select a user to edit.");
            }
            });
        $btnDeleteUser.on("click", handleDeleteUser);

        $("#change_password").on("click", function(){
            $("#confirm_password").show();
            $("#password1").show();
            $("#change_password").hide();
            $("#currentPassword").show();
            $("#passwordLabel1").text("New Password");
        });

        $usersTable = $form.find(".users-table");
        UsersTable = PHD.DataTable($usersTable, {});
        refreshUsersList();

        $usersTable.on("rowselect", "tr", function (event, dbid, $el, DataTable, DataRow) {
            if(!$btnAddUser.is(':visible')){
                handleAddUser();
            }
            multiple = false;
            UsersRowData = DataRow.data;
            id = UsersRowData.id;
            username = UsersRowData.name;
            superuser = UsersRowData.superuser;
            customers = UsersRowData.customers;
            locations = UsersRowData.locations;
            systems = UsersRowData.systems;
            if(!superuser){
                if(customers.length > 0 && locations.length > 0 && systems.length > 0){
                    if((customers[0]['privilege_level'] == locations[0]['privilege_level']) && (locations[0]['privilege_level'] == systems[0]['privilege_level'])){
                        common_privilege_level = parseInt(customers[0]['privilege_level']);
                        console.log("Multiple: False",customers[0]['privilege_level'],locations[0]['privilege_level'],systems[0]['privilege_level']);
                    }
                    else{
                        multiple = true;
                        console.log("Multiple: True",customers[0]['privilege_level'],locations[0]['privilege_level'],systems[0]['privilege_level']);
                    }
                }
                else{
                    multiple = true;
                }
            }
        });

        roleSelect = $roleSelect[0];
        roleSelect.options[0] = new Option('Monitor', 1);
        roleSelect.options[1] = new Option('Manage', 2);
        roleSelect.options[2] = new Option('Administrator', 3);
        roleSelect.options[3] = new Option('Superuser', 4);

        $form.find(".definition").popover({
            appendTo: $form
        });

        UsersForm = PHD.FormController($form, {})

            .on("formcancel", function (event) {
                PHD.currentDialog.wizard("close");
            })
            .on("formsubmit", function (event, data) {
                PHD.currentDialog.wizard("close");
            })
            .validate({
                errorLabelContainer: ".users-dialog-error-list",
                errorContainer: ".users-dialog-errors",
                showErrors: function(errorMap, errorList) {
                    $(".users-dialog-errors").find(".summary")
                        .html(gettext("Correct the following errors:"));
                    this.defaultShowErrors();
                },
                rules: {
                    username: {
                        required: true
                    },
                    password1: {
                        required: true
                    },
                    password2: {
                        required: true,
                        isPasswordMatch: true
                    }
                },
                messages: {
                    name: {
                        required: gettext("Username is required")
                    },
                    password1: {
                        required: gettext("Password is required")
                    },
                    password2: {
                        required: gettext("Confirm Password is required")
                    }
                }
            });
    }

    $('#edit-appliance').on("beforeactivationtab", function(event,ui) {
        if((ui.oldTab.text()) === " Users "){
            /* code to see if a confirmation is needed would go here */
            $(currentTarget).trigger('tabsactivateafterconfirm',ui);
        }
    });

    function refreshUsersList() {
        var users = PHD.Ajax.get('/api/users/?sid=' + PHD.appliance_sid);
        users.done(function(data) {
            allUsers = [];

            var usersList = data.data;
            usersList.forEach(function(item, index) {
                item.username = item.name;
                item.role = item.superuser;
                if(!item.vault_user){
                    if(item.superuser){
                        item.role = "Superuser";
                    }
                    else{
                        if( item.customers.length >0 &&  item.locations.length >0 && item.systems.length >0 ){
                            if(item.customers[0]['privilege_level'] == 0 && item.locations[0]['privilege_level'] == 0 && item.systems[0]['privilege_level'] == 0){
                                item.role = "None";
                            }
                            else if(item.customers[0]['privilege_level'] == 1 && item.locations[0]['privilege_level'] == 1 && item.systems[0]['privilege_level'] == 1){
                                item.role = "Monitor";
                            }
                            else if(item.customers[0]['privilege_level'] == 2 && item.locations[0]['privilege_level'] == 2 && item.systems[0]['privilege_level'] == 2){
                                item.role = "Manage";
                            }
                            else if(item.customers[0]['privilege_level'] == 3 && item.locations[0]['privilege_level'] == 3 && item.systems[0]['privilege_level'] == 3){
                                item.role = "Administrator";
                            }
                            else {
                                item.role = "Multiple";
                            }
                        }
                        else {
                            item.role = "Multiple";
                        }
                    }
                }
            });
            allUsers = $.merge(allUsers, usersList);
            UsersTable.load(allUsers);
        });
    }

    function passwordValidator(){
        var passwd = $("#password1").val();
        var confimPasswd = $("#password2").val();

        $.validator.addMethod("isPasswordMatch", function(value, element) {
            if(passwd == confimPasswd)
                return true;
            else
                return false;

        }, "Confirm password and password, do not match.");
    }

    function handleAddUser() {
        if($btnAddUser.is(':visible')){
            $(".user_add_update_buttons").hide();
            $("#add_update_users").show();
        }
        else{
            $(".user_add_update_buttons").show();
            $("#add_update_users").hide();
        }
    }

    function handleDeleteUser() {
        var url = "/api/users/"+ id + "/";
        var sid = (PHD.appliance_sid == null) ? "" : "?sid=" + PHD.appliance_sid;
        url += sid;

        PHD.Ajax
            .delete(url)
            .done(function(data) {
                var result = data.result[0];
                if (result !== undefined) {
                    if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                        console.log("SUCCESS");
                        refreshUsersList();
                    } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                        console.log("FAILURE");
                        PHD.throwError(data);
                    }
                }
            });
    }

    function handleSaveUser() {
        passwordValidator();
        if (!$form.valid()) {
            return false;
        }
        var selectedRoleID = $roleSelect.val();
        var obj = {};
        var url = "/api/users/";
        var self = this;
        var sid = (PHD.appliance_sid == null) ? "" : "?sid=" + PHD.appliance_sid;
        var customers = {},locations = {},systems = {}, customersArray = {}, locationsArray = {}, systemsArray = {};

        if(EditUser){
            if(!$("#change_password").is(':visible')){
                obj.password = $("#password1").val();
                obj.current_password = $("#currentPasswordInput").val();
            }
        }
        else{
            obj.password = $("#password1").val();
            obj.name = $("#username").val();
        }

        if(selectedRoleID == 4){
            obj.superuser = true;
        }
        else{
            obj.superuser = false;
            customers.id = PHD.appliance_sid;
            customers.privilege_level = parseInt(selectedRoleID);
            customersArray[0] = customers;
            obj.customers = customersArray;
            locations.id = PHD.appliance_sid;
            locations.privilege_level = parseInt(selectedRoleID);
            locationsArray[0] = locations;
            obj.locations = locationsArray;
            systems.id = PHD.appliance_sid;
            systems.privilege_level = parseInt(selectedRoleID);
            systemsArray[0] = systems;
            obj.systems = systemsArray;
        }

        obj = JSON.stringify(obj);
        var load = PHD.showLoadingIndicator($form);
        if(EditUser){
            url += id + "/" + sid;
            resp = PHD.Ajax.put(url, obj, load);
        }
        else{
            url += sid;
            resp = PHD.Ajax.post(url, obj, load);
        }

        resp.done(function(data) {
                // self.$form.trigger("formsubmit", [data, self.$form, self]);
                var result = data.result[0];
                if (result !== undefined) {
                    if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                        console.log("SUCCESS");
                        refreshUsersList();
                        handleAddUser();
                        PHD.hideLoadingIndicator(load);
                    } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                        console.log("FAILURE");
                       PHD.throwError(data);
                    } else {
                        // adding user, get back id.
                        console.log("SUCCESS");
                        refreshUsersList();
                        handleAddUser();
                        PHD.hideLoadingIndicator(load);
                    }
                }
            });
    }

    /* DOM Ready Function */
    $(function() {
        initForm();
    });

})(jQuery, window.PHD || (window.PHD = {}), window);
