angular.module('edit_server',['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])

    .controller('EditServerCtrl', ['$scope', '$rootScope', '$http', 'AssetService', 'ngDialog', function($scope, $rootScope, $http, AssetService, ngDialog) {

        var selectedCredential;
        var selectedCredentialID = -1;
        var associatedAppliance;
        var serverEdit = true;
        var selectedRetention,MinMaxRetentionName;
        var assetId;
        var isAssetEncrypted;

        $scope.initCtrl = function(dlg){
            switch (dlg.name){
                case 'Edit-Server':
                    $scope.editProcessing($scope.ngDialogData);
                    break;
                case 'Edit-Assets':
                    $scope.editAssetProcessing($scope.ngDialogData);
                    break;
            }
            processDialog(PHD, window);
        };

        $scope.editProcessing = function(asset){
            $scope.assets = asset;
            assetId = asset.id;
            isAssetEncrypted = asset.is_encrypted;
            $("#retentionSection").show();
            $("#id_installAgentDiv").hide();
            $("#id_server").val(asset.name);
            $("#id_ip").val(asset.ip);
            $("#edit_object_id").text(asset.id);
            $("#id_enabled").prop('checked', asset.is_enabled);
            $("#id_encrypted").prop('checked', asset.is_encrypted);
            $('#id_encrypted').prop('disabled', true);
            // TODO: App-Aware needs be fixed here. WIP
            $("#id_appAware").prop('checked', asset.app_aware);
            selectedCredential = asset.credentials != undefined ? asset.credentials.credential_id : -1;
            selectedRetention = asset.retention != undefined ? asset.retention.id_retentionPolicy : 0;
            MinMaxRetentionName = asset.retention;
            $scope.grandClient = asset.grandclient;
            associatedAppliance = $scope.grandClient !== true ? asset.system_id : $rootScope.local.id;
            AssetService.getApplianceEncryptionStatus(associatedAppliance, isAssetEncrypted, true);
        };

        $scope.editAssetProcessing = function(assets){
            $scope.assets = assets;
            $("#retentionSection").show();
            $("#id_server").hide();
            $scope.isSameSystem = $scope.isFromSameSystem(assets);
            if($scope.isSameSystem){
                if(assets.length === 1) {
                    if (assets[0].asset_type === "VMware:VM" || assets[0].asset_type === "Hyper-V:VM") {
                        // TODO: SET VIRTUAL HOST NAME
                        // TODO: Don't we want to display the name of Hyper-V:VM ?
                        console.log("Single VM edit");
                        $("#id_description").text("Edit settings of " + assets[0].asset_type + " - " + assets[0].name);
                        associatedAppliance = assets[0].system_id;
                        AssetService.getApplianceEncryptionStatus(associatedAppliance, assets[0].is_encrypted, true);
                    }
                }
                else if(assets.length > 1)
                {
                    $("#id_virtualHost_info").hide();
                    $("#id_description").text("Edit settings of " + assets.length + " assets");
                }
                $("#details_box_multiple_assets").show();
                $scope.isEncryptionEnabled = $scope.checkEncryption(assets);
                $scope.appAwareFlag = $scope.checkAppAware(assets);
                if($scope.appAwareFlag){
                    $("#credentials_is_allowed").prop("checked",true);
                    var isAppAware = $scope.isAppAware(assets);
                    if(isAppAware){
                        $("#id_appAware").prop("checked",true);
                    }
                    $("#App-Aware-Section").show();
                }
                else{
                    $("#App-Aware-Section").hide();
                    $scope.physicalAssetsFlag = $scope.checkPhysical(assets);
                    $scope.applicationsForAuthentication = $scope.checkAppsAuthSupported(assets);
                    if($scope.physicalAssetsFlag || $scope.applicationsForAuthentication){
                        $("#credentials_is_allowed").prop("checked",true);
                        $("#credential_id").enable();
                    }
                    else{
                        $("#credentials_is_allowed").prop("checked",false);
                        $("#credential_id").disable();
                    }
                }
                selectedCredential = -1;
                var credential = $scope.checkCredentials(assets);
                if(credential){
                    var credentials = {};
                    credentials = assets[0].credentials;
                    selectedCredential = credentials != null ? credentials.credential_id : -1;
                }
                $scope.checkVMwareHost =  $scope.isVMwareHost(assets);
                if($scope.checkVMwareHost){
                    $("#details_box_multiple_assets").hide();
                }
                else{
                    if($scope.isEncryptionEnabled){
                        $("#id_encrypted").prop("checked",true);
                    }
                    else{
                        $("#id_encrypted").prop("checked",false);
                    }
                }
            }
            else{
                $("#credentials_is_allowed").prop("checked",false);
                $("#credentials_is_allowed").disable();
                $("#credential_id").disable();
                $("#App-Aware-Section").hide();
            }
            selectedRetention =  0;
            if(!$scope.checkVMwareHost){
                $("#retention_is_allowed").prop("checked",true);
                var flag = $scope.checkDuplicateRetention(assets);
                if(flag === false){
                    MinMaxRetentionName = assets[0].retention;
                }
                else{
                    MinMaxRetentionName = "Multiple";
                }
                // TODO : Why are we setting null here? I am supposed to display the appliance when a single VMware:WM is being edited.
                //associatedAppliance = null;
            }
            else{
                $("#retention_is_allowed").prop("checked",false);
                $("#id_retentionPolicy").disable();
                $("#details_box_multiple_assets").hide();
            }
        };

        $scope.isFromSameSystem = function(data) {
            var index,flag = true;
            for (index = 0; index < data.length; ++index) {
                if(data[index].system_id !== 1){
                    flag = false;
                    continue;
                }
            }
            return flag;
        };

        $scope.checkDuplicateRetention = function(data) {
            var index,flag = false;
            for (index = 0; index < data.length; ++index) {
                if(data[index].min_max_policy){
                    var min = data[0].retention;
                    if(data[index].retention !== min){
                        flag = true;
                        continue;
                    }
                }
                else{
                    flag = true;
                }
            }
            return flag;
        };

        $scope.isVMwareHost = function(data) {
            var index,flag = true;
            for (index = 0; index < data.length; ++index) {
                if(data[index].asset_type !== "VMware Host"){
                    flag = false;
                    continue;
                }
            }
            return flag;
        };

        $scope.checkAppAware = function(data) {
            var index,flag = true;
            for (index = 0; index < data.length; ++index) {
                if(data[index].asset_type !== "VMware:VM"){
                    flag = false;
                    continue;
                }
            }
            return flag;
        };

        $scope.checkPhysical = function(data) {
            var index,flag = true;
            for (index = 0; index < data.length; ++index) {
                if(data[index].asset_type !== "physical"){
                    flag = false;
                    continue;
                }
            }
            return flag;
        };

        $scope.isAppAware = function(data) {
            var index,flag = true;
            for (index = 0; index < data.length; ++index) {
                if(!data[index].app_aware){
                    flag = false;
                    continue;
                }
            }
            return flag;
        };
        $scope.checkCredentials = function(data) {
            var index, flag = true;
            for (index = 0; index < data.length; ++index) {
                var cred = data[0].credential_display;
                if(data[index].credential_display !== cred){
                    flag = false;
                    continue;
                }
            }
            return flag;
        };

        $scope.checkAppsAuthSupported = function(data) {
            var index,flag;
            for (index = 0; index < data.length; ++index) {
                if(data[index].asset_type === "Oracle" || data[index].asset_type === "SharePoint" || data[index].asset_type === "VMware:VM") {
                    flag = true;
                }
                else{
                    flag = false;
                    continue;
                }
            }
            return flag;
        };

        $scope.checkEncryption = function(data) {
            var index,flag;
            for (index = 0; index < data.length; ++index) {
                if(data[index].is_encrypted) {
                    flag = true;
                }
                else{
                    flag = false;
                    continue;
                }
            }
            return flag;
        };

        function processDialog(PHD, window) {

            var $form = $("form[name=EditServerForm]");
            $scope.$form = $form;

            var credentials = [];
            var credentialsSelect;
            var $credentialsSelect = $("#credential_id");
            var applianceSelect;
            var $applianceSelect = $("#id_system");
            applianceSelect = $applianceSelect[0];
            applianceSelect.options.length = 0;
            var retentionPolicySelect;

            $scope.ipPattern = /^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$/;
            $scope.ipErrorString = "Enter valid IP address";

            $scope.credentialNamePattern = /^[ A-Za-z0-9_@./#&+-/!$%^*()=\\|:;'"<>,?`~{}\[\]]{0,64}$/;
            $scope.credentialNameErrorString = "Credential Name: Max 64 characters";

            var editServerForm = PHD.FormController($form, {
                serialize: function ($form) {
                    return $form.find("input").serialize();
                }
            });

            editServerForm
                .validate({
                    rules: {
                        ip: {
                            required: true,
                            pattern: !$scope.grandClient ? $scope.ipPattern : "N/A",
                        },
                        display_name: {
                            required: true,
                            pattern: $scope.credentialNamePattern
                        },
                        user_name: {
                            required: true
                        }
                    },
                    messages: {
                        ip: {
                            required: gettext("IP Address is required"),
                            pattern: gettext($scope.ipErrorString)
                        },
                        display_name: {
                            required: gettext("Credential name is required"),
                            pattern:gettext($scope.credentialNameErrorString)
                        },
                        user_name: {
                            required: gettext("Username is required")
                        }
                    }
                });

            function refreshSystemsList() {
                AssetService.getSystemsList().done(function (data) {
                    var appliances = data.appliance.sort(AssetService.sortIDs);
                    appliances.forEach(function (system, index) {
                        applianceSelect.options[index] = new Option(system.name, system.id);
                    });
                });
            }

            function populateCredentials() {
                credentialsSelect = $credentialsSelect[0];
                credentialsSelect.options.length = 0;
                var i = 0;
                credentialsSelect.options[i] = new Option('None', -1);
                i++;
                credentialsSelect.options[i] = new Option('New', 0);
                if (credentials.length > 0) {
                    credentials.forEach(function (credential, index) {
                        if (credential.display !== null && credential.display !== undefined && credential.display.length > 0) {
                            credentialsSelect.options[index + (i+1)] = new Option(credential.display, credential.credential_id);
                        }
                    })
                }
            };

            function refreshRetentionList () {
                return PHD.Ajax.get('/api/retention/policy/', null, this.handlePolicyError);
            };

            $credentialsSelect.on("change", function (event) {
                var dialogHeight;
                selectedCredentialID = $credentialsSelect.val();
                $scope.selectedCredentialName =  $("#credential_id option:selected").text();
                if (selectedCredentialID == 0) {
                    dialogHeight = 705;
                    $(".modal-form-credential" ).show();
                    $("#id_credentials_displayName").val("");
                    $("#id_credentials_username").val("");
                    $("#id_credentials_password").val("");
                    $("#id_domain").val("");
                } else {
                    $( ".modal-form-credential" ).hide();
                    dialogHeight = 544;
                }
                AssetService.setDialogHeight(dialogHeight);
                AssetService.clickTitleBarToFixHeight();
            });

            function initForm() {
                $form.find(".definition").popover({
                    appendTo: $form
                });

                refreshSystemsList();

                AssetService.getCredentials().done(function (data) {
                    console.log("GET credentials");
                    credentials = data.data;
                    credentials.forEach(function (credential, index) {
                        if(credential.display_name != undefined){
                            var display = credential.display_name;
                            if (credential.is_default) {
                                display += " (Default)";
                            }
                            credential.display = display;
                        }
                        else{
                            credentials.splice(credentials.indexOf(credential),1);
                        }
                    });

                    populateCredentials();
                    $(".modal-form-credential").hide();
                    AssetService.setDialogHeight(544);
                    AssetService.clickTitleBarToFixHeight();
                    $("#credential_id").val(parseInt(selectedCredential));
                });

                var strategy = PHD.Ajax.get('/api/retention/strategy/', null, handlePolicyError);
                strategy.done(function(data){
                    retentionPolicySelect = $("#id_retentionPolicy");
                    retentionPolicySelect = retentionPolicySelect[0];
                    var i = 0;
                    if(data.data.strategy === "MinMax"){
                        retentionPolicySelect.options[i] = new Option(MinMaxRetentionName, 0);
                        $rootScope.retentionStrategy = "MinMax";
                    }
                    else{
                        $rootScope.retentionStrategy = "GFS";
                        retentionPolicySelect.options[i] = new Option('None', -1);
                        i++;
                        refreshRetentionList().done(function(data){
                            $scope.isPolicyGFS = true;
                            if(data != null && data != undefined)
                                data.data.forEach(function (system, index) {
                                    retentionPolicySelect.options[index+i] = new Option(system.name, system.id);
                                });
                        });
                        $("#id_system").val(parseInt(associatedAppliance));
                        $("#id_retentionPolicy").val(parseInt(selectedRetention));
                        $("#id_server").prop("disabled", true);
                    }
                });
                //AssetService.getApplianceEncryptionStatus(associatedAppliance, isAssetEncrypted, true);
            }
            initForm();

            $scope.launchRetentionManager = function () {
                if($rootScope.retentionStrategy === "MinMax"){
                    ngDialog.open({
                        template: 'app/configure/retention/min-max.html',
                        overlay: true,
                        scope: $scope,
                        data: $scope.assets,
                        name: 'MinMaxRetention',
                        ngDialogStyle:'width:600px; height:470px;',
                        closeByDocument: false,
                        closeByEscape: false
                    });
                }
                else{
                    ngDialog.open({     //Gives error currently
                        template: 'app/configure/retention/retentionpolicy.html',
                        scope: $scope,
                        overlay:true,
                        name: 'Retention-Policy',
                        ngDialogStyle:'width:300px; height:400px;',
                        // GFS TODO - enlarge dialog once we have weekly/monthly/yearly settings
                        //ngDialogStyle:'width:700px; height:400px;',
                        closeByDocument: false,
                        closeByEscape: false
                    });
                }
                
            };

            $scope.editMultipleAssets = function () {
                console.log("editMultipleAssets - serverEdit : "+ serverEdit);

                var obj = {};
                var credentials = {};

                console.log("selected = " + selectedCredentialID);
                if(selectedCredentialID == 0){
                    credentials.display_name = $("#id_credentials_displayName").val();
                    credentials.username = $("#id_credentials_username").val();
                    credentials.password = $("#id_credentials_password").val();
                    credentials.domain = $("#id_domain").val();
                    credentials.is_default = $("#id_default").prop("checked");
                    obj.credentials = credentials;
                }
                else if(selectedCredentialID == -1){
                    obj.credential_id = -1;
                }
                else{
                    obj.credential_id = parseInt(selectedCredentialID);
                }

                var client_url = "/api/credentials/bind/client/";
                var instance_url = "/api/credentials/bind/instance/";
                var encrypt_enable_url = "/api/encryption/enable-instance/";
                var encrypt_disable_url = "/api/encryption/disable-instance/";
                var putObj = JSON.stringify(obj);
                var hasErrors = false;
                $scope.LoadIndicator = PHD.showLoadingIndicator("body", true, "Saving...");

                obj = {};
                var instance_ids = "";
                $scope.assets.forEach(function(asset){
                    if($scope.physicalAssetsFlag && asset.file_level_instance_id){
                        instance_ids += asset.file_level_instance_id + ",";
                    }
                    else{
                        instance_ids += asset.id + ",";
                    }
                });
                var str = instance_ids.substring(0, instance_ids.length - 1);
                obj.instance_id = str;
                putObj = JSON.stringify(obj);
                var encrypt_url = $("#id_encrypted").prop("checked") ? encrypt_enable_url : encrypt_disable_url;

                var resp = PHD.Ajax.put(encrypt_url + "?sid=" + PHD.appliance_sid, putObj, null, null);
                resp.done(function(data) {
                    if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                        var error = data.result[0].message;
                        console.log("The error is:" + error);
                        if (error != undefined) {
                            hasErrors = true;
                        }
                    }
                });

                if($("#credentials_is_allowed").is(':visible')){
                    if($scope.appAwareFlag || $scope.applicationsForAuthentication){
                        obj = {};
                        var instance_ids="";
                        $scope.assets.forEach(function(asset){
                            instance_ids += asset.id + ",";
                        });
                        var str = instance_ids.substring(0, instance_ids.length - 1);
                        obj.instance_ids = str;
                        if($("#id_appAware").prop("checked")){
                            obj.app_aware = true;
                        }
                        else{
                            obj.app_aware = false;
                        }

                        parseInt(selectedCredentialID);
                        putObj = JSON.stringify(obj);
                        var resp = PHD.Ajax.put(instance_url + parseInt(selectedCredentialID) + "/?sid=" + PHD.appliance_sid, putObj, $scope.LoadIndicator, null);

                        resp.done(function(data) {
                            PHD.hideLoadingIndicator($scope.LoadIndicator);
                            if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                                var error = data.result[0].message;
                                console.log("The error is:" + error);
                                if (error != undefined) {
                                    hasErrors = true;
                                }
                            }
                        });

                        if (!hasErrors) {
                            $scope.closeThisDialog();
                            $(document).trigger("assetChange");
                        }
                    }
                    else if($scope.physicalAssetsFlag){
                        obj = {};
                        var clientInfo = {};
                        var i=0;
                        $scope.assets.forEach(function(asset){
                            var client = {};
                            client['clientID'] = asset.id;
                            client['name'] = asset.name;
                            client['credential_display'] = $scope.selectedCredentialName;
                            clientInfo[i] = client;
                            i++;
                        });
                        obj.clients = clientInfo;
                        parseInt(selectedCredentialID);
                        putObj = JSON.stringify(obj);
                        var resp = PHD.Ajax.put(client_url + parseInt(selectedCredentialID) + "/?sid=" + PHD.appliance_sid, putObj, $scope.LoadIndicator, handlePhysicalAssetsError);

                        resp.done(function(data) {
                            PHD.hideLoadingIndicator($scope.LoadIndicator);
                            if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                                var error = data.result[0].message;
                                console.log("The error is:" + error);
                                if (error != undefined) {
                                    hasErrors = true;
                                }
                            }
                            if (!hasErrors) {
                                $scope.closeThisDialog();
                                $(document).trigger("assetChange");
                            }
                        });
                    }

                }

               /* $scope.assets.forEach(function(asset) {
                    var resp;
                    if (asset.asset_type === ASSET_TYPE_PHYSICAL) {
                        obj.clientID = asset.id;
                        putObj = JSON.stringify(obj);
                        resp = PHD.Ajax.put(client_url + obj.credential_id + "/?sid=" + asset.system_id, putObj, null, null);
                    } else {
                        obj = {};
                        obj.credential_id = parseInt(selectedCredentialID);
                        obj.app_aware = true; // TODO, add to dialog for a VM.
                        putObj = JSON.stringify(obj);
                        resp = PHD.Ajax.put(instance_url + asset.id + "/?sid=" + asset.system_id, putObj, null, null);
                    }

                    resp.done(function(data) {
                        if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                            var error = data.result[0].message;
                            console.log("The error is:" + error);
                            if (error != undefined) {
                                hasErrors = true;
                            }
                        }
                    });
                });*/


            };

            $scope.editAsset = function () {
                if ((!$scope.$form.valid())) {
                    return false;
                }
                console.log("Save asset clicked - serverEdit : "+ serverEdit);
                var obj={};
                // associatedAppliance is being passed as query param. Form element(id_system) is not used by the API.
                var associatedAppliance = $("#id_system").val();
                var selectedCredentialNow = $credentialsSelect.val();
                obj.name = $("#id_server").val();
                obj.os_type = "Windows";
                obj.priority = 300;
                obj.is_enabled = true;
                obj.is_synchable = false;
                obj.use_ssl = false;
                obj.is_auth_enabled = (selectedCredentialNow == -1) ? false : true;
                obj.is_encrypted = $("#id_encrypted").prop("checked") ? true : false;
                obj.app_aware = $("#id_appAware").prop("checked") ? true : false;

                var hostinfo = {};
                if (!$scope.grandClient) {
                    hostinfo.ip = $("#id_ip").val();
                }

                console.log("selected = " + selectedCredentialNow);
                if(selectedCredentialNow == 0){
                    var credentials = {};
                    credentials.display_name = $("#id_credentials_displayName").val();
                    credentials.username = $("#id_credentials_username").val();
                    credentials.password = $("#id_credentials_password").val();
                    credentials.domain = $("#id_domain").val();
                    credentials.is_default = $("#id_default").prop("checked");
                    obj.credentials = credentials;
                }
                else if(selectedCredentialNow == -1){
                    obj.credential_id = -1;
                }
                else{
                    obj.credential_id = parseInt(selectedCredentialNow);
                }
                obj.host_info = hostinfo;

                var base_url = "/api/clients/";

                obj = JSON.stringify(obj);
                console.log("selected retentionPolicy = " + $("#id_retentionPolicy").val());
                //TODO: VALIDATE the retentionID usage once the API is ready to attach the retention policy with the Asset.
                obj.retention_id = $("#id_retentionPolicy").val();
                console.log("PUT called to edit Asset with ID : " + assetId + " -- associatedAppliance : " + associatedAppliance);
                base_url +=assetId + "/";
                $scope.LoadIndicator = PHD.showLoadingIndicator("body", true, "Editing ...");
                resp = PHD.Ajax.put(base_url + "?sid=" +  associatedAppliance, obj, null, handleAssetError);

                resp.done(function(data) {
                    PHD.hideLoadingIndicator($scope.LoadIndicator);
                    processDialog(PHD, window);
                    $scope.closeThisDialog();
                    var result = data.result;
                    if (Array.isArray(result)) {
                        result = result[0];
                    }
                    if (result !== undefined) {
                        if (parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                            ngDialog.close("Info-Error-Dialog");
                            console.log("SUCCESS");
                            $(document).trigger("assetChange");
                        } else if (parseInt(result.code) === AJAX_RESULT_ERROR) {
                            console.log("FAILURE");
                            ngDialog.open({
                                dialogType: 'ERROR',
                                modelDialogId:'Info-Error-Dialog',
                                dialogMessage: data,
                                overlay: true
                            });
                        } else {
                            console.log("SUCCESS");
                            $(document).trigger("assetChange");
                        }
                    }
                });
            };
        }

        function handlePhysicalAssetsError(jqXHR, textStatus, errorThrown){
            PHD.hideLoadingIndicator($scope.LoadIndicator);
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.messages !== undefined) {
                    var errors = data.messages+"";
                    console.log(errors);
                    var errorArray = {};
                    errorArray = errors.split('|');
                    var index = errorArray.indexOf("");
                    errorArray.splice(index,1);
                    console.log(errorArray);
                    ngDialog.open({
                        template: 'app/configure/environments/MultipleErrorDialog.html',
                        overlay:true,
                        ngDialogStyle:'width:600px; height:320px;',
                        closeByDocument: false,
                        closeByEscape: false,
                        data: errorArray,
                        modelDialogId:'ErrorDialog',
                        scope:$scope
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.Ajax.ajaxError(jqXHR, textStatus, errorThrown);
            }
        };

        function handleAssetError (jqXHR, textStatus, errorThrown) {
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var error = data.result[0].message;
                    console.log("The error is:" + error);
                    PHD.hideLoadingIndicator($scope.LoadIndicator);
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'ErrorDialog',
                        scope:$scope,
                        dialogMessage: error,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.Ajax.ajaxError(jqXHR, textStatus, errorThrown);
            }
        };

        $scope.onConfirmError = function () {
            ngDialog.close('ErrorDialog');
        };

        function handlePolicyError(jqXHR, textStatus, errorThrown) {
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined &&
                    data.result[0].message.indexOf("strategy of the system is not GFS") != -1) {
                    console.log("Not GFS, don't allow assignment of policies");
                    $scope.isPolicyGFS = false;
                    $('#retentionSection').prop('disabled', true);
                    $('.retentionPolicyList').prop('disabled', true);
                    $('.retentionPolicyList').attr('title', data.result[0].message);
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.Ajax.ajaxError(jqXHR, textStatus, errorThrown);
            }
        };

        // Initialize the controller.
        $scope.$on('ngDialog.opened', function(event,obj) { $scope.initCtrl(obj) });
    }]);
