angular.module('retention',['ngDialog'])
    .config(['ngDialogProvider', function (ngDialogProvider) {
        ngDialogProvider.setDefaults({
            plain: false,
            showClose: true,
            closeByDocument: true,
            closeByEscape: true,
            appendTo: false,
            preCloseCallback: function (value) {

            }
        });
    }])

    .controller('MinMaxRetentionCtrl', ['$scope', '$rootScope', '$http','ngDialog', function($scope, $rootScope, $http, ngDialog) {

        var Load;

        $scope.initCtrl = function(dlg){
            switch (dlg.name) {
                case 'MinMaxRetention':
                    $scope.processMinmaxRetentionDialog($scope.ngDialogData);
                    break;
            }
        };

        $scope.minDaysSpinOptions = { "min": 0, "max": 9999, "step": 1};
        $scope.maxDaysSpinOptions = { "min": 0, "max": 9999, "step": 1};
        $scope.legalHoldSpinOptions = { "min": 0, "max": 9999, "step": 1};

        $scope.processMinmaxRetentionDialog = function(data) {
            var $form = $("#min_max_retention_form");
            $form.find(".definition").popover({
                appendTo: $form
            });

            $("#min_days").spinner($scope.minDaysSpinOptions);
            $("#max_days").spinner($scope.maxDaysSpinOptions);
            $("#hold_days").spinner($scope.legalHoldSpinOptions);

            if($scope.ngDialogData.length >1) {
                data = $scope.ngDialogData;

                var flag1 = $scope.checkDuplicate(data, "retention_min");

                if (flag1 === false && data[0].min_max_policy.retention_min > 0) {
                    $("#id_use_minimum").prop("checked", true);
                    $("#min_days").val(data[0].min_max_policy.retention_min);
                }

                var flag2 = $scope.checkDuplicate(data, "retention_max");

                if (flag2 === false && data[0].min_max_policy.retention_max > 0) {
                    $("#id_use_maximum").prop("checked", true);
                    $("#max_days").val(data[0].min_max_policy.retention_max);
                }

                var flag3 = $scope.checkDuplicate(data, "legal_hold");

                if (flag3 === false) {
                    if (data[0].min_max_policy.legal_hold == -1) {
                        $("#hold_forever").prop("checked", true);
                    }
                    else {
                        $("#hold_days").val(data[0].min_max_policy.legal_hold);
                        if (data[0].min_max_policy.legal_hold > 0) {
                            $("#legal_hold").prop("checked",true);
                        }
                    }
                }
            }
            else{
                data = data.min_max_policy;
                if (data.retention_min > 0) {
                    $("#id_use_minimum").prop("checked", true);
                }
                $("#min_days").val(data.retention_min);
                if (data.retention_max > 0) {
                    $("#id_use_maximum").prop("checked", true);
                }
                $("#max_days").val(data.retention_max);
                if(data.legal_hold === -1){
                    $("#hold_forever").prop("checked", true);
                } else {
                    $("#hold_days").val(data.legal_hold);
                    if (data.legal_hold > 0) {
                        $("#legal_hold").prop("checked",true);
                    }
                }
            }

            $scope.MinimumClicked();
            $scope.MaximumClicked();
            $scope.HoldForeverClicked();
        };

        $scope.checkDuplicate = function(data, type) {
            var index,flag = false;
            for (index = 0; index < data.length; ++index) {
                if(data[index].min_max_policy){
                    var min = data[0].min_max_policy[type];
                    if(data[index].min_max_policy[type] !== min){
                        flag = true;
                    }
                }
                else{
                    flag = true;
                }
            }
            return flag;
        };

        $scope.HoldForeverClicked = function() {
            if($("#hold_forever").prop("checked")){
                $scope.legal_hold = -1;
                $("#legal_hold").disable();
                $("#hold_days").disable();
                $("#hold_days").spinner("option", "disabled", true);
                $("#legal_hold").prop("checked",false);
            }
            else{
                $("#legal_hold").enable();
            }
            if( $("#legal_hold").prop("checked")){
                $("#hold_forever").disable();
                $("#hold_forever").prop("checked",false);
                $("#hold_days").enable();
                $("#hold_days").spinner("option", "disabled", false);
            }
            else{
                $("#hold_days").disable();
                $("#hold_forever").enable();
            }

        };

        $scope.MinimumClicked = function() {
            if($("#id_use_minimum").prop("checked")){
                $("#min_days").enable();
            } else {
                $("#min_days").disable();
            }
        };

        $scope.MaximumClicked = function() {
            if($("#id_use_maximum").prop("checked")){
                $("#max_days").enable();
            } else {
                $("#max_days").disable();
            }
        };

        $scope.AddMinMaxRetentionInfo = function() {
            var obj = {},retentionInfo = {},multipleRetentionInfo = {};
            if( $("#id_use_minimum").prop("checked")) {
                retentionInfo.retention_min = Number($("#min_days").val());
            } else {
                retentionInfo.retention_min = 0;
            }
            if( $("#id_use_maximum").prop("checked")) {
                retentionInfo.retention_max = Number($("#max_days").val());
            } else {
                retentionInfo.retention_max = 0;
            }
            if( $("#hold_forever").prop("checked")){
                retentionInfo.legal_hold = -1;
            } else if ($("#legal_hold").prop("checked")) {
                retentionInfo.legal_hold = Number($("#hold_days").val());
            } else {
                retentionInfo.legal_hold = 0;
            }

            if($scope.ngDialogData.length >1){
                data = $scope.ngDialogData;
                data.forEach(function(asset, index) {
                    if(asset.min_max_policy){
                         var instance_id = asset.min_max_policy.instance_id;
                        multipleRetentionInfo.instance_id = instance_id;
                        multipleRetentionInfo.retention_min = retentionInfo.retention_min;
                        multipleRetentionInfo.retention_max = retentionInfo.retention_max;
                        multipleRetentionInfo.legal_hold = retentionInfo.legal_hold;
                        obj[index] = multipleRetentionInfo;
                    }
                    multipleRetentionInfo = {};
                })
            }
            else{
                data = $scope.ngDialogData.min_max_policy;
                $scope.instance_id = data.instance_id;
                retentionInfo.instance_id = $scope.instance_id;
                obj.retentionInfo = retentionInfo;
            }

            var base_url = "/api/retention/min-max/";
            obj = JSON.stringify(obj);
            Load = PHD.showLoadingIndicator("body", true, "Saving...");
            var resp = PHD.Ajax.put(base_url + "?sid=" +  PHD.appliance_sid, obj, null, handlePolicyError);

            resp.done(function(data) {
                PHD.hideLoadingIndicator(Load);
                var result = data.result[0];
                ngDialog.close('MinMaxRetention');
                if(parseInt(result.code) === AJAX_RESULT_SUCCESS) {
                    console.log("SUCCESS");
                    $scope.closeThisDialog();
                    $(document).trigger("assetChange");
                } else if(parseInt(result.code) === AJAX_RESULT_ERROR) {
                    console.log("FAILURE");
                    ngDialog.open({
                        dialogType: 'ERROR',
                        dialogMessage: data,
                        overlay:true
                    });
                }
                //PHD.currentDialog.wizard("close");
            });
        };

        function handlePolicyError(jqXHR, textStatus, errorThrown) {
            PHD.hideLoadingIndicator(Load);
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var error = data.result[0].message;
                    console.log("The error is:" + error);
                    ngDialog.open({
                        dialogType:'Error',
                        modelDialogId:'MinMaxErrorDialog',
                        scope:$scope,
                        dialogMessage: error,
                        onConfirmOkButtonClick:'onConfirmError()'
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.Ajax.ajaxError(jqXHR, textStatus, errorThrown);
            }
        }

        $scope.onConfirmError = function () {
            ngDialog.close('MinMaxErrorDialog');
        };

        // Initialize the controller.
        $scope.$on('ngDialog.opened', function(event, obj) { $scope.initCtrl(obj) });
    }]);
