angular.module('backupJobModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid','ui.grid.resizeColumns','ui.grid.autoResize','fileBrowserDialogApp','ngGrid','ui.bootstrap','inventory','checklist-model','ui.grid.selection', 'backup-now-dialog'])
.directive('angularDatepicker', function ($parse) {
    return function (scope, element, attrs, controller) {
        var ngModel = $parse(attrs.ngModel);
        $(function(){
            element.datepicker({
               showOn: "both",
                buttonText: '<img src="assets/images/calendar.png" width="24" height="24">',
                dateFormat: DATE_FORMAT,
                onSelect:function (dateText, inst) {
                    scope.$apply(function(scope){
                        // Change binded variable
                        ngModel.assign(scope, dateText);
                    });
                }
            });
        });
    }
}).directive('angulartimeEntry', function ($rootScope) {
     return {
        restrict: 'A',
        scope:false,
        link: function(scope,elm,attrs){
            elm.timeEntry({
            })
        }
    }
})
.config(['ngDialogProvider', function (ngDialogProvider) {
    ngDialogProvider.setDefaults({
        plain: false,
        closeByDocument: true,
        closeByEscape: true,
        appendTo: false,
        preCloseCallback: function (value) {
        }
    });
}])
.factory('sharedGridData', function(){
    return {
        tempArray:[]
        
    };
})
.service('includeExcludeLabelService', function () {
	   var label = 'inclusion';
         return {
            getLabel: function () {
                return label;
            },
            setLabel: function(value) {
                label = value;
            }
        };
})

.controller('backupJobController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc) {
        $scope.jobName='Backup Job'; //default job name plaveholder
        $scope.backupJobNameModel='Backup Job';
        $scope.joborder={};
        //init empty joboredr
        $scope.joborder.name = "Backup Job"; //TODO init to textfield from HTML
        $scope.joborder.type = "backup"; //this is always backup.
        $scope.joborder.verify = "none";
        $scope.joborder.app_id = "1"; //default assetType is server and hence app_id will be 1 i.e. file-level
        $scope.joborder.sid = "1"; // default sid = 1
        $scope.joborder.clients = [];
        $scope.joborder.instances = [];
        $scope.joborder.calendar = [];
        $scope.scheduleTypeSelection = {
                name: 'Scheduled'
        };
        $scope.errorField=false;
        $scope.startDateError=false;
        $scope.dayError=false;
        $scope.startTimeError=false;
        $scope.recuranceError=false;
        $scope.recursTime=[{id:0,name:'Hour'},{id:1,name:'Minutes'}];
        $scope.isScheduled = true;
        $scope.joborder.storage = null;
		$scope.recursEveryError = false;
        
        $scope.isIncrementalOrDifferntial= false;
        
        $scope.joborder.email_report = true;
        $scope.joborder.failure_report = true;
        $scope.joborder.storage = null;
        $scope.selectedTreeNode = [];
        $scope.selectedAsset =[];
        $scope.calendarDays=[
             {'name':'SUN',   'value' : "0"},
             {'name':'MON',   'value' : "1"},
             {'name':'TUE',  'value' : "2"},
             {'name':'WED','value' : "3"},
             {'name':'THU', 'value' : "4"},
             {'name':'FRI',   'value' : "5"},
             {'name':'SAT', 'value' : "6"}
            ];
        $scope.backupModes = [];
        $scope.backupModesForNow=[];
        $scope.backupModesForSchedule=[];
        $scope.backupStrategies=[];
        $scope.backup_types = {};
        $scope.backupModesforJob = {};
        $scope.scheduleForm = {};
        $scope.hideEdit=false;
        $scope.daysFull=[{name:'SUN',id:'run_on_sun_full',val:"0"},{name:'MON',id:'run_on_mon_full',val:"1"},{name:'TUE',id:'run_on_tue_full',val:"2"},{name:'WED',id:'run_on_wed_full',val:"3"},{name:'THR',id:'run_on_thr_full',val:"4"},{name:'FRI',id:'run_on_fri_full',val:"5"},{name:'SAT',id:'run_on_sat_full',val:"6"}];
        $scope.daysIncr=[{name:'SUN',id:'run_on_sun_incr',val:"0"},{name:'MON',id:'run_on_mon_incr',val:"1"},{name:'TUE',id:'run_on_tue_incr',val:"2"},{name:'WED',id:'run_on_wed_incr',val:"3"},{name:'THR',id:'run_on_thr',val:"4"},{name:'FRI',id:'run_on_fri',val:"5"},{name:'SAT',id:'run_on_sat_incr',val:"6"}];

        
        var templateWithTooltip = '<div style="word-wrap:normal;font-size:1.2em;padding-top:2px;" title="{{row.getProperty(col.field)}}">{{row.getProperty(col.field)}}</div>';
        $scope.inventoryColumnDefs = [ 
            {field:'id',displayName:'Id',visible:false},
            {field:'nodeId',displayName:'Node Id',visible:false},
            {field: 'name',displayName:'Name',width:'30%'},
            {field:'rules',displayName:'Protection Rules',cellClass: 'cellToolTip',cellTemplate: templateWithTooltip,width:'50%'},
            {field:'edit' ,displayName:'', cellTemplate: '<div ng-hide="hideEdit" style="padding-left:25px;padding-top:5px;" ng-click="openEditSettingServerDialog(row.entity,row.getProperty(col.field), col.field)"><img src="assets/images/edit_pencil.png" style="height:14px;cursor:pointer;"/><span style="font-size:11px;padding-left:5px;font-weight:bold">Edit<span></div>',width:'20%'} 
        ];
        $scope.inventoryGridOptions={columnDefs: $scope.inventoryColumnDefs,data:'inventoryData', enableHorizontalScrollbar:0,enableVerticalScrollbar:2,resizable: true};
        $scope.assetType={};
        $scope.assetTypeList=[
            { name: "Agent-Based Assets", hypervisor:"1" ,id:INVENTORY_TYPE_FAMILY_CLIENT},
            { name: "VMware Assets", hypervisor:"3" ,id:INVENTORY_TYPE_FAMILY_VMWARE},  
            { name: "Hyper-V Assets", hypervisor:"2" ,id:INVENTORY_TYPE_FAMILY_HYPER_V},
            { name: "Xen Assets", hypervisor:"4" ,id:INVENTORY_TYPE_FAMILY_XEN},
            { name: "NAS",    hypervisor:"1"    ,id:INVENTORY_TYPE_FAMILY_CLIENT_NAS}
        ];

        if(!($rootScope.isCE || $rootScope.isGoogle)){

            $scope.assetTypeList.push({ name: "Exchange", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_EXCHANGE});
            $scope.assetTypeList.push({ name: "Oracle", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_ORACLE});
            $scope.assetTypeList.push({ name: "SQL", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_SQL});
            $scope.assetTypeList.push({ name: "Sharepoint", hypervisor:"0" ,id:INVENTORY_TYPE_FAMILY_SHAREPOINT});

        }

        if($scope.isEdit){
            $http({
                method: 'get',
                url : '/api/joborders/'+$scope.jobId
            }).success(function(data, status, headers){
                 $scope.joborder=data.data[0];
                 document.getElementById("backupJobID").value=$scope.joborder.name;
                 $scope.assetType.id= $scope.getAssetType($scope.joborder);
                 $scope.isHypervisorHostSelected = $scope.isRegexJob($scope.joborder);
                 $scope.setRecurrenceModel();
                 $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
                 //$scope.checkNodesOnLoadEdit();
             }).error(function(response){
                ngDialog.open({
                    dialogType:'Error',
                    dialogMessage:response.result[0].message
                })
            });

        }else{
            $scope.assetType.id= parseInt($scope.selectedAssetType);
            setTimeout(function(){
            $scope.filterInventory();}, 1000);
        }
        
       $scope.setRecurrenceModel = function(){
            for (var i =0 ; i <$scope.joborder.calendar.length ; i ++){
             if(typeof($scope.joborder.calendar[i].recurrence) !='undefined'){
                 $scope.joborder.calendar[i].recursCheck  =true;
                 if($scope.joborder.calendar[i].recurrence < 60){
                     $scope.joborder.calendar[i].recursTimeSelect=1;
                 }else{
                     $scope.joborder.calendar[i].recurrence = $scope.joborder.calendar[i].recurrence/60;
                     $scope.joborder.calendar[i].recursTimeSelect=0;
                 }
                 $scope.recurstimeModeChange(i,$scope.joborder.calendar[i].recursTimeSelect);
             }else{
                 $scope.joborder.calendar[i].recursCheck  =false;
             }
            }
        }
        $scope.treeConfig = {
            core : {
                multiple : !$scope.isNAS, //TODO check if it needs to single select in case of NAS
                animation: true,
                error : function(error) {$log.error('treeCtrl: error from js tree - ' + angular.toJson(error));},
                check_callback : true,
                worker : true
            },
            types : {
                default : {icon : 'icon-hv-datacenter icon'},
                star : {icon : 'icon-hv-host icon'},
                cloud : {icon : 'icon-hv-host icon'}
            },
            version : 1,
            plugins : ['types','checkbox','search']
        };
        
        $scope.setAssetType=function(){
            if($rootScope.isSelectedJobFileLevel){
                 $scope.assetType.id= $scope.assetTypeList[0].id;
            }else if($rootScope.isSelectedJobNAS){
                 $scope.assetType.id= $scope.assetTypeList[3].id;
            }else{
                 $scope.assetType.id= $scope.assetTypeList[3];
            }
        }

        $scope.filterInventory = function(){
            $('#jstreeDivId').jstree(true).uncheck_all();
            $scope.joborder={};
            //init empty joboredr
            $scope.joborder.name = "Backup Job"; //TODO init to textfield from HTML
            $scope.joborder.type = "backup"; //this is always backup.
            $scope.joborder.verify = "none";
            $scope.joborder.app_id = "1"; //default assetType is server and hence app_id will be 1 i.e. file-level
            $scope.joborder.sid = "1"; // default sid = 1
            $scope.joborder.clients = [];
            $scope.joborder.instances = [];
            $scope.joborder.calendar = [];
            $scope.joborder.storage = null;
            $scope.joborder.email_report = true;
            $scope.joborder.failure_report = true;
            $scope.joborder.storage = null;

            if($scope.assetType.id == INVENTORY_TYPE_FAMILY_HYPER_V || $scope.assetType.id == INVENTORY_TYPE_FAMILY_EXCHANGE || $scope.assetType.id == INVENTORY_TYPE_FAMILY_SQL 
                || $scope.assetType.id == INVENTORY_TYPE_FAMILY_ORACLE|| $scope.assetType.id == INVENTORY_TYPE_FAMILY_SHAREPOINT){
                $scope.hideEdit=true;
            }else{
                $scope.hideEdit=false;
            }
            $scope.isNAS = false;
            if($scope.assetType.id == INVENTORY_TYPE_FAMILY_CLIENT_NAS){
                $scope.isNAS = true;
                $('#jstreeDivId').jstree(true).settings.core.multiple = false;
            } else {
                $('#jstreeDivId').jstree(true).settings.core.multiple = true;
            }
            $rootScope.treeData=[];
            $scope.selectedAsset =[];
            $scope.inventoryData =[];
            $protectService.loadTreeData($http,$scope,$rootScope,$scope.assetType.id,false);
        };
        
        $scope.getAssetType = function(joborder){
            var app_id= joborder.app_id;

            if(app_id === APP_ID_FILE_LEVEL){
                if(joborder.clients[0].name.indexOf("-NAS-RRC")>-1){ //hack till backend fix it.
                    return INVENTORY_TYPE_FAMILY_CLIENT_NAS;
                }
                return INVENTORY_TYPE_FAMILY_CLIENT;
            } else if(app_id === APP_ID_VMWARE){
                return INVENTORY_TYPE_FAMILY_VMWARE;
            } else if(app_id === APP_ID_XEN){
                return INVENTORY_TYPE_FAMILY_XEN;
            } else if(app_id === APP_ID_HYPERV_2008_R2 || app_id === APP_ID_HYPERV_2012){
                return INVENTORY_TYPE_FAMILY_HYPER_V;
            } else if (app_id === APP_ID_EXCHANGE_2003 || app_id === APP_ID_EXCHANGE_2007 || app_id === APP_ID_EXCHANGE_2010 || app_id === APP_ID_EXCHANGE_2013) {
                return INVENTORY_TYPE_FAMILY_EXCHANGE;
            }else if (app_id === APP_ID_SQL_SERVER_2005 || app_id === APP_ID_SQL_SERVER_2008 || app_id === APP_ID_SQL_SERVER_2008_R2 
                || app_id === APP_ID_SQL_SERVER_2012 || app_id === APP_ID_SQL_SERVER_2014) {
                return INVENTORY_TYPE_FAMILY_SQL;
            }else if (app_id === APP_ID_SHAREPOINT_2007 || app_id === APP_ID_SHAREPOINT_2010 || app_id === APP_ID_SHAREPOINT_2013) {
                return INVENTORY_TYPE_FAMILY_SHAREPOINT;
            }else if (app_id === APP_ID_ORACLE_11 || app_id === APP_ID_ORACLE_12 || app_id === APP_ID_ORACLE_10) {
                return INVENTORY_TYPE_FAMILY_ORACLE;
            }
        }

        $scope.getClientOrInstance = function(joborder){
            var app_id= joborder.app_id;
            if(app_id === APP_ID_FILE_LEVEL){
                if(joborder.clients[0].name.indexOf("-NAS-RRC")>-1){ //hack till backend fix it.
                    return joborder.clients;
                }
                return joborder.clients;
            } else {
                /* for all other apps, return instances.
                    APP_ID_EXCHANGE_2003 = 2,
                    APP_ID_EXCHANGE_2007 = 3,
                    APP_ID_EXCHANGE_2010 = 4,
                    APP_ID_EXCHANGE_2013 = 5,
                    APP_ID_SQL_SERVER_2005 = 21,
                    APP_ID_SQL_SERVER_2008 = 22,
                    APP_ID_SQL_SERVER_2008_R2 = 23,
                    APP_ID_SQL_SERVER_2012 = 24,
                    APP_ID_SQL_SERVER_2014 = 25,
                    APP_ID_ARCHIVE = 30,
                    APP_ID_VMWARE = 40,
                    APP_ID_HYPERV_2008_R2 = 50,
                    APP_ID_HYPERV_2012 = 51,
                    APP_ID_ORACLE_11 = 100,
                    APP_ID_ORACLE_12 = 101,
                    APP_ID_ORACLE_10 = 102,
                    APP_ID_SHAREPOINT_2007 = 110,
                    APP_ID_SHAREPOINT_2010 = 111,
                    APP_ID_SHAREPOINT_2013 = 112; */
                return joborder.instances;
            }
        };

        $scope.uncheckNotEligibleNode=function(uncheckNodeId){
            var node_id='li#'+uncheckNodeId;
            $('#jstreeDivId').jstree(true).uncheck_node(node_id);
        }

        $scope.readyTree=function(event){
            if($scope.isEdit){
                 setTimeout(function(){
                   $scope.checkNodesOnLoadEdit();
                   $rootScope.loadRegex();
                }, 1000);
            } else {
                if($scope.selectedNodeList.length>0){
                    setTimeout(function(){
                       $scope.checkNodesOnPreSelect();
                       $rootScope.initRegex(false);
                    }, 1000);
                }
            }
        };

        $scope.checkNodesOnPreSelect=function(){
            $('#jstreeDivId').jstree(true).open_all();
            for(var i=0; i< $scope.selectedNodeList.length ; i++){
                var node_id='li#';
                node_id = node_id +$scope.selectedNodeList[i];
                $('#jstreeDivId').jstree(true).check_node(node_id);
            }
        }
        $scope.checkNodesOnLoadEdit=function(){
                var nodeIdArray =Object.keys($('#jstreeDivId').jstree(true)._model.data);
                var arrayAssets = $scope.getClientOrInstance($scope.joborder);
                $('#jstreeDivId').jstree(true).open_all();
                if(arrayAssets !=undefined){
                    for(var i=0; i< arrayAssets.length ; i++){
                        var node_id='li#';
                        for(var j=0 ;j<nodeIdArray.length;j++){
                            if (nodeMatches(nodeIdArray[j], arrayAssets[i], $scope.joborder)) {
                                arrayAssets[i].nodeId = nodeIdArray[j];
                                if(arrayAssets[i].incl_list == undefined || arrayAssets[i].incl_list == null){
                                    arrayAssets[i].incl_list = [];   
                                }
                                if(arrayAssets[i].excl_list == undefined || arrayAssets[i].excl_list == null){
                                    arrayAssets[i].excl_list = [];   
                                }

                                $scope.selectedAsset[nodeIdArray[j]] = arrayAssets[i];
                                node_id = node_id+nodeIdArray[j];
                                break;
                            }
                        }
                        if ($scope.isHypervisorHostSelected) {
                            var obj = inventorysvc.nodeToObject(node_id);
                            $rootScope.joborderHypervisorID = obj.host_guid;
                        }
                        $('#jstreeDivId').jstree(true).check_node(node_id);
                    }
                    $('#jstreeDivId').jstree(true).close_all();
                }
        };

        function nodeMatches(node, asset, joborder) {
            var match = false;
            var asset_node = joborder.sid + "_";
            if (joborder.app_id === APP_ID_FILE_LEVEL) {
                asset_node += asset.id;
                match = node.indexOf(asset_node) === 0;
            } else {
                asset_node += joborder.client_id + "_" + joborder.app_id + "_";
                if (node.indexOf(asset_node) === 0) {
                    var parts = node.split('_');
                    match = (asset.id === parseInt(parts[parts.length - 1]));
                }
            }
            return match;
        }


        $scope.deslectNodeFun = function(e,item){
            if (item.node.data !== undefined && item.node.data.type === INVENTORY_ID_VMWARE_ESX_SERVER) {
                $rootScope.joborderHypervisorID = item.node.id;
                $scope.isHypervisorHostSelected = false;
            } else {
                if(item.selected.length == 0){
                    $scope.joborder.clients =[];
                    $scope.selectedAsset =[];
                }
                if($scope.joborder.sid == inventorysvc.nodeToObject(item.node.id).system_id){
                    delete $scope.selectedAsset[item.node.id];
                }
                $scope.inventoryData =[];
                var nodeIdArray =Object.keys($scope.selectedAsset);
                for(var j=0 ;j<nodeIdArray.length;j++){
                    var obj = $scope.selectedAsset[nodeIdArray[j]];
                    obj.rules = $scope.setProtectionRule(obj.incl_list,obj.excl_list);
                    $scope.inventoryData.push(obj);
                }
                $(window).resize();
            }
        };

        $scope.slectNodeFun = function(e,item){
                
            if(item.selected.length>1){
                if($scope.joborder.sid == inventorysvc.nodeToObject(item.node.id).system_id){
                    if($scope.selectedAsset[item.node.id] ==null || $scope.selectedAsset[item.node.id] == undefined){
                        $scope.selectedAsset[item.node.id] ={nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id,incl_list:[],excl_list:[]};
                    }
                }else{
                     $scope.uncheckNotEligibleNode(item.node.id);
                }
            }else{
                $scope.joborder.sid = inventorysvc.nodeToObject(item.node.id).system_id;
                $scope.joborder.app_id = inventorysvc.nodeToObject(item.node.id).app_id;
                if (item.node.data !== undefined && item.node.data.type === INVENTORY_ID_VMWARE_ESX_SERVER) {
                    $scope.isHypervisorHostSelected = true;
                    $rootScope.joborderHypervisorID = item.node.id;
                } else {
                    if($scope.selectedAsset[item.node.id] == undefined ||$scope.selectedAsset[item.node.id] ==null){
                        $scope.selectedAsset[item.node.id] ={nodeId:item.node.id,name:item.node.text,id:inventorysvc.nodeToObject(item.node.id).client_id,incl_list:[],excl_list:[]};
                    }
                }
            }

            $scope.inventoryData =[];
            var nodeIdArray =Object.keys($scope.selectedAsset);
            for(var j=0 ;j<nodeIdArray.length;j++){
                var obj = $scope.selectedAsset[nodeIdArray[j]];
                obj.rules = $scope.setProtectionRule(obj.incl_list,obj.excl_list);
                $scope.inventoryData.push(obj);
            }
            $(window).resize();

        };

        $scope.setProtectionRule = function(incl_list,excl_list) {
            var protectionruleInclusion="Inclusions =[ ";
            var protectionruleExclusion="Exclusions =[ ";
            var protectionRules ="";

            if(incl_list!=undefined && incl_list!=null &&incl_list.length>0){
                protectionruleInclusion = protectionruleInclusion+incl_list.toString()+" ] ";
                protectionRules = protectionRules + protectionruleInclusion;
            }

            if(excl_list!=undefined && excl_list!=null &&excl_list.length>0){
                protectionruleExclusion = protectionruleExclusion+excl_list.toString()+" ] ";
                protectionRules = protectionRules + protectionruleExclusion;
            }

            return protectionRules;
        }

        $scope.refreshInventoryData = function(assets){
            var assets = assets || false;
            if (assets) {
                $scope.selectedAsset = assets;
            }
            $scope.inventoryData =[];
            var nodeIdArray =Object.keys($scope.selectedAsset);
            for(var j=0 ;j<nodeIdArray.length;j++){
                var obj = $scope.selectedAsset[nodeIdArray[j]];
                obj.rules = $scope.setProtectionRule(obj.incl_list,obj.excl_list);
                $scope.inventoryData.push(obj);
            }
            $(window).resize();

        }

        $scope.applyModelChanges = function() {
            if($scope.isScheduled){
                $scope.getBackupTypeForSelectedStrategies($scope.backupModesforJob.name);
                
            }
            
            
        }

        $scope.search = function(){
            var to = false;   
            if(to) { clearTimeout(to); }
            to = setTimeout(function () {
                var v = $('#inventorySearchInputId').val();
                $('#jstreeDivId').jstree(true).search(v);
            }, 200);
        }

        $scope.addNewInventory=function(item,id){
        }

        $scope.getProtectionRulesArray = function(inclusionData,exclusionData){
        }

        $scope.functiontofindIndexByKeyValue = function(arraytosearch, key, valuetosearch) {
            for (var i = 0; i < arraytosearch.length; i++) {
                if (arraytosearch[i][key] == valuetosearch) {
                  return i;
                 }
            }
                return null;
        };

        $scope.isRegexJob = function(job) {
            return (job !== undefined && job.regular_expressions !== undefined && job.regular_expressions.length > 0);
        };

/*************************************************************************
2ndstep
*/  
        $scope.validationForForm=function(){
            $scope.errorField=false;
            $scope.startDateError=false;
            $scope.dayError=false;
            $scope.startTimeError=false;
            $scope.recuranceError=false;
			$scope.endHourError =false;
			$scope.recursEveryError = false;
			
			
            if ($scope.joborder.calendar === undefined || $scope.joborder.calendar.length == 0 ){
                return true;
            }else{
                for (var i =0 ; i < $scope.joborder.calendar.length ; i++){
			        if($scope.joborder.calendar[i].run_on.length <=0){
                        $scope.errorField=true;
                        $scope.dayError=true;
                    }
                  if(typeof($scope.joborder.calendar[i].start_date) == 'undefined'){
                        $scope.errorField=true;
                        $scope.startDateError=true;
                    }
                 if(typeof($scope.joborder.calendar[i].start_time) == 'undefined'){
                        $scope.errorField=true;
                        $scope.startTimeError=true;
                   }
				   if( $scope.joborder.calendar[i].recursCheck){
                      if(typeof($scope.joborder.calendar[i].recurrence )==='undefined'  || $scope.joborder.calendar[i].recurrence==null || $scope.joborder.calendar[i].recurrence==="" || $scope.joborder.calendar[i].recurrence==0 ){
                          $scope.errorField=true;
                          $scope.recuranceError=true;
                          $scope.recursEveryError=true;
                      }
                  }
				  if( $scope.joborder.calendar[i].recursCheck){
					  if(typeof($scope.joborder.calendar[i].end_hour) == 'undefined' || ($scope.joborder.calendar[i].end_hour< 0 && $scope.joborder.calendar[i].end_hour > 24) ){
						   $scope.errorField=true;
						   $scope.endHourError=true;
					  }
				  }
                  
                  if($scope.errorField){
                      $scope.error_backupType =$scope.joborder.calendar[i].backup_type;
                        break;
                    }
                    
                }
                
                return !$scope.errorField;
            }
      
        }
        
        $scope.removeUnwantedKeys = function(){
            for (var i =0 ; i < $scope.joborder.calendar.length ; i++){
                if(!$scope.joborder.calendar[i].recursCheck){
                    delete $scope.joborder.calendar[i].recurrence;
                }
                else if ($scope.joborder.calendar[i].recursTimeSelect == 0 ){
                    $scope.joborder.calendar[i].recurrence =$scope.joborder.calendar[i].recurrence * 60; 
                } 
                 delete $scope.joborder.calendar[i].$$hashKey;
                 delete $scope.joborder.calendar[i].recursTimeSelect;
                 delete $scope.joborder.calendar[i].recursCheck;
            }
            
        }
        $scope.nextWizard = function($event){
            if(wizardTitle == "Select Items"){
                console.log($scope.selectedAsset);
                 if( Object.keys($scope.selectedAsset).length == 0){
                            return;
                  }
                  $rootScope.$broadcast("nextBtnClick"); 
                    if($scope.isEdit == true){
                     $scope.isScheduled = true;
                     $scope.scheduleTypeSelection.name ='Scheduled';
                    }
                  $scope.getStorage();
                  $scope.getBackupStrategies();
                 
                
                   
            }
            if(wizardTitle == "Define Job Settings"){
                 if(document.getElementById("backupJobID").value == ""){
                    $scope.jobNameError=true;    
                    return;
                 }
                 $scope.jobNameError=false; 
                 if($scope.validationForForm()){
                     $scope.joborder.name=document.getElementById("backupJobID").value;
                    if($scope.assetType.id ===INVENTORY_TYPE_FAMILY_CLIENT || $scope.assetType.id ===INVENTORY_TYPE_FAMILY_CLIENT_NAS){
                        $scope.joborder.clients =[];// $scope.j
                        var nodeIdArray =Object.keys($scope.selectedAsset);
                        for(var j=0 ;j<nodeIdArray.length;j++){
                            $scope.joborder.app_id = inventorysvc.nodeToObject($scope.selectedAsset[nodeIdArray[j]].nodeId).app_id;
                            $scope.selectedAsset[nodeIdArray[j]].id = parseInt($scope.selectedAsset[nodeIdArray[j]].id);
                            $scope.joborder.clients.push($scope.selectedAsset[nodeIdArray[j]]);
                        }
            
                    }else{

                        $scope.joborder.instances =[];// $scope.j
                        var nodeIdArray =Object.keys($scope.selectedAsset);
                        for(var j=0 ;j<nodeIdArray.length;j++){
                            $scope.joborder.app_id = inventorysvc.nodeToObject($scope.selectedAsset[nodeIdArray[j]].nodeId).app_id;
                            $scope.selectedAsset[nodeIdArray[j]].id = parseInt(inventorysvc.nodeToObject($scope.selectedAsset[nodeIdArray[j]].nodeId).instance_id);
                            $scope.joborder.instances.push($scope.selectedAsset[nodeIdArray[j]]);
                        }

                    }
                     var jobOrderUrl='';
                     var dataObj ={};
                     var httpMethod='';
                      var meassageforLoad=(!$scope.isEdit)?"Creating Job":"Updating Job";
                      var loadJobindicator = PHD.showLoadingIndicator("body", true, meassageforLoad); 
                    if($scope.isScheduled){
                         $scope.removeUnwantedKeys();   
                        if($scope.isEdit == true){
                            httpMethod = 'put';
                            jobOrderUrl = '/api/joborders/'+$scope.joborder.id+'/?sid='+$scope.joborder.sid;

                         }else{
                            jobOrderUrl = '/api/joborders/?sid='+$scope.joborder.sid;
                            httpMethod = 'post';
                         }dataObj =JSON.stringify($scope.joborder)
                          console.log($scope.joborder);
                    }else{
                         console.log($scope.backupModesforJob.name);
                         if(typeof ($scope.joborder.calendar) != 'undefined'){
                            delete $scope.joborder.calendar;
                         }
                         $scope.joborder.backup_type=$scope.backupModesforJob.name;
                         console.log($scope.joborder);
                         jobOrderUrl = '/api/backups/?sid='+$scope.joborder.sid;
                         dataObj =JSON.stringify($scope.joborder)
                         httpMethod = 'put';
                    }

                     $http({ method: httpMethod,
                         url : jobOrderUrl,
                         data: dataObj
                     }).success(function(data, status, headers){
                         PHD.hideLoadingIndicator(loadJobindicator);
                         if (!$scope.isScheduled) {
                             ngDialog.open({
                                 modelDialogId:'backupNowDialog',
                                 template: 'app/protect/backup-job/backupNowDialog.html',
                                 scope:$scope,
                                 data: data.data,
                                 overlay:true,
                                 ngDialogStyle:"width:700px;height:400px;"
                             });
                         } else {
                             if (!$scope.isEdit) {
                                 var message = "Job created successfully!<br/><br/>Use the Job Manager tab to view and manage your newly created job";
                                 console.log(data);
                                 console.log(status);
                                 console.log(headers);

                                 ngDialog.open({
                                     dialogType: 'information',
                                     dialogMessage: message
                                 });
                             } else {
                                 ngDialog.close('backup-physical-dailog');
                             }
                         }

                     }).error(function(response) {
                         PHD.hideLoadingIndicator(loadJobindicator);
                         ngDialog.open({
                             dialogType:'Error',
                             modelDialogId:'BackupPostErrorDialog',
                             scope:$scope,
                             dialogMessage: response.result[0].message,
                             onConfirmOkButtonClick:'onConfirmError()'
                         });
                     });
                 }else{
                     console.log('validation error');
                 }
            }
        };
        
        $scope.onConfirmError = function () {
            ngDialog.close('BackupPostErrorDialog');
        };

         $scope.getBackupMode = function() {
            if($scope.scheduleTypeSelection.name == "Now") {
                $scope.backupJobNameModel='On-Demand';
                $scope.jobNameError=false;    
                $scope.isScheduled = false;  
                $scope.joborder.calendar=[];
                $scope.backupModes=$scope.backupModesForNow;
                $scope.backupModesforJob.name= $scope.backupModes[0];
            } else {
                $scope.backupJobNameModel='Backup Job';
                $scope.isScheduled = true;  
                $scope.backupModes=$scope.backupModesForSchedule;
                $scope.backupModesforJob.name= $scope.backupModes[0];
                $scope.getBackupTypeForSelectedStrategies($scope.backupModes[0]);
				
            }
            
			 
		};
        $scope.getBackupTypeForSelectedStrategies = function(backupStratiges){
           $scope.joborder.calendar=[];
            var dataArray=[];
            for (var i =0 ; i <$scope.backupStrategies.length ; i++ ){
                if(backupStratiges == $scope.backupStrategies[i].name){
                dataArray =  $scope.backupStrategies[i].backup_types;
                }
            }
            for (j = 0 ; j < dataArray.length ; j++){
            var calendarObj={
                run_on:["1"],
                start_date:new Date().toLocaleDateString(),
                start_time:"05:00 AM",
                backup_type:dataArray[j],
                recursCheck:false,
                recursTimeSelect:0,
                recurrence:1,
                schedule_run: 0,
				end_hour:0
                };
                 $scope.joborder.calendar.push(calendarObj);
                 $scope.recurstimeModeChange(j,0);
		   }
        }
	    $scope.setBackupModeForEdit = function(){
            var StrategiesObject={};
            for (var i=0 ; i < $scope.backupStrategies.length ; i++){
                var backupstrategyType="";
                for(var j=0 ; j < $scope.backupStrategies[i].backup_types.length ; j++){
                backupstrategyType +=$scope.backupStrategies[i].backup_types[j];
                }
                StrategiesObject[backupstrategyType]=$scope.backupStrategies[i].name;
            }
            var backupType="";
            for ( var i = 0 ; i < $scope.joborder.calendar.length; i++){
             backupType +=$scope.joborder.calendar[i].backup_type;
            }
            var selectedBackupType=StrategiesObject[backupType];
            $scope.backupModesforJob.name= $scope.backupModes[$scope.backupModes.indexOf(selectedBackupType)];
        }
        $scope.getBackupStrategies = function() {
                var scheduleApi = "/api/backups/strategies/"+$scope.joborder.app_id+"/";
                if($scope.isNAS){
                    scheduleApi = "/api/backups/strategies/"+$scope.joborder.app_id+"/?isNAS=true";
                }
                $http.get(scheduleApi)
                .then(function(response){
                        $scope.backup_types ={};
                        $scope.backupModesForSchedule = [];
                        $scope.backupModesForNow = response.data.on_demand;
                        var tempMap = new Object();
                        $scope.backupStrategies=response.data.strategies;
                        for(var i=0; i< response.data.strategies.length;i++) {    
                            $scope.backup_types[response.data.strategies[i].name] = response.data.strategies[i].backup_types;
                            $scope.backupModesForSchedule[i]=response.data.strategies[i].name;
                        }
                        if($scope.isScheduled){
                            $scope.backupModes=$scope.backupModesForSchedule;
                             if ($scope.isEdit){
                                 $scope.setBackupModeForEdit();
                                 
                             }else{
                                 $scope.backupModesforJob.name= $scope.backupModes[0];
                             }
                        }else {
                            $scope.backupModes=$scope.backupModesForNow;
                             $scope.backupModesforJob.name= $scope.backupModes[0];
                        }
                    if (!$scope.isEdit){
                        $scope.getBackupMode();
                    }
                },function(reason){
                    console.log(reason);
                });
            }
            $scope.recurstimeModeChange	= function(index,timeSelect){
                var timmerId="#recurs_spinner_field"+index;
               if(timeSelect == 0){
                   $(timmerId).spinner({min: 1, max: 12});
               }else{
                    $(timmerId).spinner({min: 1, max: 60});
               }
			}
          $scope.getStorage = function(){
                var storageApi = "/api/storage/?sid="+$scope.joborder.sid+"&usage=backup";
                $scope.backupTarget ={};

                 $http.get(storageApi)
                .then(function(response){ 
                    $scope.backupTarget.targets =[];
                     $scope.joborder.storage = response.data.storage[0].name;
                     console.log(response.data.storage.length);
                    for(var j=0;j<response.data.storage.length ;j++){
                        $scope.backupTarget.targets.push({name:response.data.storage[j].name,value:response.data.storage[j].name});
                        if ($scope.isEdit && $scope.joborder.storage != "") {
                            $scope.joborder.storage = $scope.joborder.storage;
                        } else {
                            if(response.data.storage[j].is_default){
                                $scope.joborder.storage = response.data.storage[j].name;
                            }
                        }
                    }
                },function(reason){
                    console.log(reason);
                });
            }
        
       
        $scope.openEditSettingServerDialog = function(row,cell,column){

            $scope.selectedAssetId = row.id;
            $scope.selectedAssetName = row.name;
            $scope.selectedNodeId = row.nodeId;
            if($scope.assetType.id == INVENTORY_TYPE_FAMILY_VMWARE || $scope.assetType.id == INVENTORY_TYPE_FAMILY_XEN){
                 ngDialog.open({
                            template: 'app/protect/backup-job/edit-vmware.html',
                            scope: $scope,
                            overlay:true,
                            modelDialogId:'edit-vmware-dailog',
                            ngDialogStyle:'width:600px;height:520px;',
                            preCloseCallback: function (value) {}
                });
            }
            if($scope.assetType.id ==INVENTORY_TYPE_FAMILY_CLIENT_NAS ||$scope.assetType.id == INVENTORY_TYPE_FAMILY_CLIENT ){
                ngDialog.open({
                            template: 'app/protect/backup-job/edit-asset.html',
                            scope: $scope,
                            overlay:true,
                            modelDialogId:'edit-asset-dailog',
                            ngDialogStyle:'width:600px;height:520px;',
                            preCloseCallback: function (value) {}
                });
            }
      }

}])
.controller('editAssetController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','dataToBeShared','includeExcludeLabelService',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,dataToBeShared,includeExcludeLabelService) {
        $scope.tab = 1;
        $scope.currentTab = 1;
        var index = $scope.$parent.selectedAssetName.indexOf("-NAS-RRC");
        if(index != undefined && index !=null && index > -1){
            $scope.isNAS = true;
        }

        $scope.inclusionGridOptions = {};       
        $scope.inclusionColumnDefs = [{field: 'name',displayName:'Name'},
                                            {field:'delete',displayName:'',cellTemplate:'<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity,1)"/></div>'}];
        $scope.exclusionFileGridOptions = {};      
        $scope.exclusionFileColumnDefs = [{field: 'name',displayName:'Name'},
                                            {field:'delete',displayName:'',cellTemplate:'<div><img src="assets/images/delete.png" style="height:14px;cursor:pointer;padding-left:15px;" ng-click="deleteRow(row.entity,2)"/></div>'}];

        $scope.inclusionGridOptions = {columnDefs: $scope.inclusionColumnDefs,data:'inclusionData',enableHorizontalScrollbar:0,};
        $scope.exclusionFileGridOptions = {columnDefs: $scope.exclusionFileColumnDefs,data:'exclusionData',enableHorizontalScrollbar:0,};


        $scope.inclusionData = [];
        $scope.exclusionData = [];
        $scope.originalInclusionData = [];
        $scope.originalExclusionData = [];
        for(var i =0;i<$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list.length;i++){
            $scope.inclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list[i]});
            $scope.originalInclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list[i]});
        }

        for(var i =0;i<$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list.length;i++){
            $scope.exclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list[i]});
            $scope.originalExclusionData.push({name:$scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list[i]});
        }
        
        $scope.showCurrentTab = function(currentTab){
            $scope.currentTab = currentTab;
            $(window).resize();
        }

        $scope.selectTab = function (setTab){
            $scope.tab = setTab;
        };
        $scope.isSelected = function(checkTab) {
            return $scope.tab === checkTab;
        };

        $scope.deleteRow = function(row,grid){
            if(grid == 1){
                var index = $scope.inclusionData.indexOf(row);
                $scope.inclusionData.splice(index, 1);
            }else{
                var index = $scope.exclusionData.indexOf(row);
                $scope.exclusionData.splice(index, 1); 
            }
        }

        $scope.openBrowseFileDialog  = function(tab){
            var dataObj={};
            var fileId = $scope.$parent.selectedAssetId;
            var dirName = "";
			var inclusionExclusionLabel ="";
			
			if(tab == 1){
				inclusionExclusionLabel = "inclusion";
				includeExcludeLabelService.setLabel(inclusionExclusionLabel);
			}else{
				
				inclusionExclusionLabel = "exclusion";
				includeExcludeLabelService.setLabel(inclusionExclusionLabel);
			}
			
            if($scope.isNAS){
                var index = $scope.$parent.selectedAssetName.indexOf("-NAS-RRC");
                dirName ="&dir="+"/mnt/nas/"+$scope.$parent.selectedAssetName.substring(0,index);
            }

            var url = '/api/clients/files/'+fileId+'/?sid='+inventorysvc.nodeToObject($scope.$parent.selectedNodeId).system_id+dirName;
            var fileBrowserTreeNodeUrl = '/api/clients/files/'+fileId+'/?sid='+inventorysvc.nodeToObject($scope.$parent.selectedNodeId).system_id+'&dir=';
            dataObj = {fileBrowserTreeNodeUrl:fileBrowserTreeNodeUrl,url:url};
            
            fileBrowserDialogService.getfileBrowserTreeData(dataObj); // to open andget data for file browser tree.
        }
        $scope.savefileServerSettingData = function(){
             $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list =[];
             $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list =[];
            if($scope.inclusionData===undefined || $scope.inclusionData===null || $scope.inclusionData.length===0){
                $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list =[];
            } else {
                for(var i =0;i<$scope.inclusionData.length;i++){
                    $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].incl_list.push($scope.inclusionData[i].name);
                }
            }
            if($scope.exclusionData===undefined || $scope.exclusionData===null || $scope.exclusionData.length===0){
                $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list =[];
            } else {
                for(var i =0;i<$scope.exclusionData.length;i++){
                    $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list.push($scope.exclusionData[i].name);
                }
            }
            $scope.$parent.$parent.refreshInventoryData();
            unbind();
            ngDialog.close('edit-asset-dailog');
        }
        $scope.closeEditServerSettingDialog =function(){
            unbind();
                if($scope.isInclusionExclusionChanged()){ 
                  ngDialog.open({
                     template: 'app/protect/backup-job/confirm-backup-job.html',
                     scope: $scope,
                     overlay: true,
                     modelDialogId: 'confirm-edit-backup',
                     showHelpArticleButton: true,
                     ngDialogStyle: 'width:46em; height:15em;  top: 70px;left: 27px;right: 27px;'
                 });
               } else {
                ngDialog.close('edit-asset-dailog');
            }
        }
        
         $scope.isInclusionExclusionChanged = function(){
            $scope.isInclusionModified = false;
            if(angular.equals($scope.inclusionData, $scope.originalInclusionData)!==true || angular.equals($scope.exclusionData,$scope.originalExclusionData)!==true ){
                $scope.isInclusionModified = true;
            }else{
                $scope.isInclusionModified = false;
            }
            return $scope.isInclusionModified;
        }
        
        $scope.closeEditBackupDialogs = function(){
            ngDialog.close('edit-asset-dailog');
            ngDialog.close('confirm-edit-backup');
        }
        $scope.cancelEditBackup = function(){
            ngDialog.close('confirm-edit-backup'); 
        }

        var unbind= $scope.$watch(function(){
            return dataToBeShared.objectList;
        }, function(newValue,oldValue){
             if(!angular.isUndefined(newValue) &&(angular.isUndefined(oldValue) || newValue.name != oldValue.name)){
                 console.log(newValue);
                 $scope.addBrowseItem(newValue);
                 dataToBeShared.objectList=undefined;
             }
        });

        $scope.addIncludeText = function(){
           var obj = {name:$scope.includeText};
            var uniqueFlag = containsObject(obj,$scope.inclusionData);
            if(uniqueFlag != true && $scope.includeText != undefined){
                $scope.inclusionData.push(obj);
            }
            $scope.includeText="";
        }
         
        $scope.addExcludeText = function(){
            var obj = {name:$scope.excludeText};
            var uniqueFlag = containsObject(obj,$scope.exclusionData);
            if(uniqueFlag != true && $scope.excludeText != undefined){
                $scope.exclusionData.push(obj);
            }
            $scope.excludeText="";
        }
        function containsObject(obj, list) {
            if(!angular.isUndefined(list)){
                var i;
                for (i = 0; i < list.length; i++) {
                    if (list[i].name === obj.name) {
                        return true;
                    }
                }
            }
            return false;
        }

        $scope.addBrowseItem = function(listArray){
            for(var i=0;i<listArray.length;i++){
                var dirName = "";
                if($scope.isNAS){
                    var index = $scope.$parent.selectedAssetName.indexOf("-NAS-RRC");
                    if(index != undefined && index !=null && index > -1){
                        dirName ="/mnt/nas/"+$scope.$parent.selectedAssetName.substring(0,index)+"/";
                    }
                }
                listArray[i].name = dirName+listArray[i].name;
                if($scope.currentTab == 1) {
                    $scope.inclusionData.push(listArray[i]);
                }else{
                    $scope.exclusionData.push(listArray[i]);
                }
            }
      
            $(window).resize();
        }
		
		$scope.addPresets = function(tab){
        	if(tab == 1){
				$scope.inclusionData = [];
		    	for(var i=0;i< $scope.originalInclusionData.length;i++){
				  $scope.inclusionData.push( $scope.originalInclusionData[i]);
				}
			}else{
				$scope.exclusionData =[];
				for(var j=0;j<$scope.originalExclusionData.length;j++){
				  $scope.exclusionData.push($scope.originalExclusionData[j]);
				}
		    }
		}
}]).controller('editVmWareController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','dataToBeShared',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,dataToBeShared) {
        $scope.tab =1;
        $scope.excluded_datastore = $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list;
        $scope.showCheckError=false;
        console.log('editVmWareController');
        $scope.gridOptions={
                    multiSelect: true,
                    showHeader: false,
                    enableFullRowSelection : true,
                    gridMenuShowHideColumns:false,
                    columnDefs: [
                          { field: 'name', showHeader: false, displayName:"" },
                         { field: 'id', visible:false , showHeader: false,}
                    ]
                };
    
        //$scope.gridOptions.data=[{'name':'Abc','id':'1'}];
         $scope.selectTab = function (setTab){
            $scope.tab = setTab;
        };
        $scope.isSelected = function(checkTab) {
            return $scope.tab === checkTab;
        };

        var selectedNodeId = $scope.$parent.selectedNodeId;
        console.log(selectedNodeId);
        var url ='/api/inventory/'+selectedNodeId +'/?disks=1'
         console.log(url);
         $http({
            method: 'GET',
            url: url
        }).success(function(data, status, headers) {
             console.log(data.inventory.nodes);
          $scope.gridOptions.data=data.inventory.nodes;
           
        }).error(function(data, status, headers) {
            console.log('api_inventory_error');
        });
        
         $scope.gridOptions.onRegisterApi = function(gridApi){
                    //set gridApi on scope
                    $scope.gridApi = gridApi;
                    gridApi.selection.on.rowSelectionChanged($scope,function(row){
                        if (row.isSelected){
                            $scope.showCheckError=false;
                        }
                    });

                };
         $scope.gridOptions.isRowSelectable =function(row){
                    for(var i=0; i<$scope.excluded_datastore.length;i++){
                        if($scope.excluded_datastore[i] === row.entity.name){
                            return true;
                        }
                    }
                    row.setSelected(true);
                    return true;
                };


        $scope.saveVmWareSettingData = function(){
            $scope.selectedDataStores = $scope.gridApi.selection.getSelectedRows();
            //console.log($scope.selectedDataStores);
            if($scope.selectedDataStores.length > 0){
                $scope.showCheckError=false;
            }else{
                $scope.showCheckError=true;
            }
            
            if(!$scope.showCheckError){
                var dataStoreGridData = $scope.gridOptions.data;
                var filterExcludeDataStore = dataStoreGridData.filter(function(obj) { return $scope.gridApi.selection.getSelectedRows().indexOf(obj) == -1; })
                //console.log(filterExcludeVolumeArray);
                $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list =[];
                for(var i=0;i<filterExcludeDataStore.length;i++){
                    $scope.excluded_datastore.push(filterExcludeDataStore[i].name);
                    $scope.$parent.$parent.selectedAsset[$scope.$parent.selectedNodeId].excl_list.push(filterExcludeDataStore[i].name);
                }
                $scope.$parent.$parent.refreshInventoryData();
                ngDialog.close('edit-vmware-dailog');
            }
        }
        

        $scope.closeEditServerSettingDialog =function(){
            $scope.closeThisDialog();
        }

}]).controller('filterVMwareController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics','fileBrowserDialogService','sharedGridData','$protectService','inventorysvc','dataToBeShared',
    function($scope, $rootScope, $http, ngDialog, wizardService, $analytics,fileBrowserDialogService,sharedGridData,$protectService,inventorysvc,dataToBeShared) {

        $scope.containers = [
            { name: 'Enter name',       id: -1},
            { name: 'Datacenters',      id: 4 },
            { name: 'ESX Clusters',     id: 5 },
            { name: 'ESX Servers',      id: 6 },
            { name: 'Datastores',       id: 7 },
            { name: 'Resource Pools',   id: 8 },
            { name: 'vApps',            id: 9 },
            { name: 'Folders',          id: 10 },
            { name: 'VM DisplayName',   id: 11 }
        ];

        $scope.actions = [
            { name: 'Enter action',     id: -1},
            { name: 'Equal',            id: 0 },
            { name: 'Not Equal',        id: 1 },
            { name: 'Contains',         id: 2 },
            { name: 'Not Contains',     id: 3 },
            { name: 'Starts with',      id: 4 },
            { name: 'Ends With',        id: 5 }
        ];

        $scope.default_regex = {
            container: $scope.containers[0],
            action: $scope.actions[0],
            filter: '',
            isEdit: false
        };
        $scope.regexList = [];
        $scope.ROW_HEIGHT = 28;

        $scope.addRegex = function(regex) {
            var regex = regex || null;
            if (regex) {
                $scope.regexList.push(regex);
            } else {
                $scope.regexList.push(jQuery.extend(true, {}, $scope.default_regex));
                $scope.regexList[$scope.regexList.length - 1].container = $scope.containers[0];
                $scope.regexList[$scope.regexList.length - 1].action = $scope.actions[0];
            }

            var $tree = $("#jstreeDivId");
            var $controls = $("#protect-tree-controls");
            var $footer = $("#protect-treeview-footer-dialog");
            $tree.height($tree.height() - $scope.ROW_HEIGHT);
            $controls.height($controls.height() + $scope.ROW_HEIGHT);
            $footer.height($footer.height() + $scope.ROW_HEIGHT);
        };

        $scope.removeRegex = function() {
            var $tree = $("#jstreeDivId");
            var $controls = $("#protect-tree-controls");
            var $footer = $("#protect-treeview-footer-dialog");

            $scope.regexList.pop();
            console.log($footer);
            $tree.height($tree.height() + $scope.ROW_HEIGHT);
            $controls.height($controls.height() - $scope.ROW_HEIGHT);
            $footer.height($footer.height() - $scope.ROW_HEIGHT);
            if ($scope.regexList.length == 0) {
                $scope.joborder.instances =[];
                $scope.$parent.$parent.refreshInventoryData([]);
            }
        };

        $scope.applyRegex = function() {
            var node = $rootScope.joborderHypervisorID;
            var url = '/api/hypervisor/regex/?sid=' + 1;
            var regex = $scope.getRegex();
            console.log('regex');
            console.log(regex);
            var obj = {};
            obj.host = node;
            obj.regex = regex;
            var json_obj = JSON.stringify(obj);
            var load = PHD.showLoadingIndicator('body', true, 'Searching for VMs that meet the filter criteria....');
            var resp = PHD.Ajax.put(url, json_obj, load, handleError);
            resp.done(function(data) {
                console.log(data.data);
                $scope.selectedAsset = [];
                for (var i = 0; i < data.data.length; i++) {
                    var vm = data.data[i];
                    var item = {};
                    item.nodeId = $rootScope.joborderHypervisorID + '_' + vm.instance_id;
                    item.name = vm.name;
                    item.id = vm.instance_id;
                    item.incl_list = [];
                    item.excl_list = [];
                    $scope.selectedAsset[item.nodeId] = item;
                }
                $scope.$parent.$parent.refreshInventoryData($scope.selectedAsset);
                $scope.joborder.regular_expressions = regex;
                // if this is the first regex, allow just ONE more.
                if ($scope.regexList.length <= 1) {
                    $scope.addRegex();
                }
            });
        };

        function handleError(jqXHR, textStatus, errorThrown) {
            if(jqXHR.status === 500) {
                var data = jqXHR.responseJSON;
                if (data !== undefined && data.result !== undefined && data.result[0] !== undefined) {
                    var error = data.result[0].message;
                    console.log("The error is:" + error);
                    //PHD.hideLoadingIndicator(AddStorage);
                    ngDialog.open({
                        dialogType:'retry',
                        modelDialogId:'regex-dialog',
                        scope:$scope,
                        dialogMessage: error
                    });
                } else {
                    PHD.throwError(data);
                }
            } else {
                PHD.Ajax.ajaxError(jqXHR, textStatus, errorThrown);
            }
        }

        $scope.getRegex = function() {
            var regex = [];
            for (var i = 0; i < $scope.regexList.length; i++) {
                var item = $scope.regexList[i];
                var obj = {};
                obj.container_id = item.container.id;
                obj.action_id = item.action.id;
                obj.filter = item.filter;
                regex.push(obj);
            }
            return regex;
        };

        $rootScope.initRegex = function(isEdit) {
            $scope.regexList = [];
            var $tree = $("#jstreeDivId");
            var $controls = $("#protect-tree-controls");
            var $footer = $("#protect-treeview-footer-dialog");
            if (isEdit) {
                $tree.height(450);
                $controls.height(30);
                $footer.height(30);
            } else {
                $tree.height(400);
                $controls.height(30);
                $footer.height(30);
            }
        };

        $rootScope.loadRegex = function() {
            $rootScope.initRegex(true);
            if ($scope.joborder.regular_expressions !== undefined) {
                for (var i = 0; i < $scope.joborder.regular_expressions.length; i++) {
                    var short_regex = $scope.joborder.regular_expressions[i];
                    var container = _.findWhere($scope.containers, {"id": short_regex.id});
                    var action =  _.findWhere($scope.actions, {"id": short_regex.action});
                    var regex = {};
                    regex.container = container;
                    regex.action = action;
                    regex.filter = short_regex.filter;
                    // so that it will be disabled, part of schedule.
                    regex.isEdit = true;
                    console.log(regex);
                    $scope.addRegex(regex);
                }
            }
        };
}]);