angular.module('protect', ['angulartics', 'angulartics.google.analytics','ngDialog','inventory'])
	
	.service('$protectService', function(){

		var iconFunc =function getIconForTreeNodeType(t) {
			if(t === INVENTORY_ID_CLIENT_AIX || t === INVENTORY_ID_CLIENT_DOS
				||t === INVENTORY_ID_CLIENT_FREE_BSD || t === INVENTORY_ID_CLIENT_HPUX
				||t === INVENTORY_ID_CLIENT_I_SERIES || t === INVENTORY_ID_CLIENT_LINUX
				||t === INVENTORY_ID_CLIENT_MAC || t === INVENTORY_ID_CLIENT_NETWARE
				||t === INVENTORY_ID_CLIENT_OES || t === INVENTORY_ID_CLIENT_OS2
				||t === INVENTORY_ID_CLIENT_SGI || t === INVENTORY_ID_CLIENT_SCO
				||t === INVENTORY_ID_CLIENT_SOLARIS || t === INVENTORY_ID_CLIENT_UNIX
				||t === INVENTORY_ID_CLIENT_WINDOWS || t === INVENTORY_ID_CLIENT_OTHER) {
				return "icon-uui-asset";
			} else if (t === INVENTORY_ID_EXCHANGE_APPLICATION) {
				return "icon-uui-asset-exchange";
			} else if (t === INVENTORY_ID_SQL_SERVER) {
				return "icon-uui-asset-sql";
			} else if (t === INVENTORY_ID_ORACLE_APPLICATION) {
				return "icon-uui-asset-oracle";
			} else if (t === INVENTORY_ID_SHAREPOINT_APPLICATION) {
				return "icon-uui-asset-sharepoint";
			} else if (t === INVENTORY_ID_HYPER_V_SERVER) {
				return "icon-uui-asset-hyperv";
			} else if(t === INVENTORY_ID_VMWARE_VM || t === INVENTORY_ID_HYPER_V_VM || t=== INVENTORY_ID_XEN_VM){
				return "icon-hv-vm";
			}else if(t === INVENTORY_ID_SQL_DATABASE || t === INVENTORY_ID_EXCHANGE_DATABASE || t === INVENTORY_ID_ORACLE_DATABASE || t === INVENTORY_ID_SHAREPOINT_FARM) {
				return "icon-database";
			}else if(t === INVENTORY_ID_VMWARE_CLUSTER || t === INVENTORY_ID_XEN_SERVER_IN_A_POOL){
				return "icon-hv-cluster";
			}else if(t === INVENTORY_ID_VMWARE_ESX_SERVER || t === INVENTORY_ID_XEN_POOL_MASTER || t=== INVENTORY_ID_XEN_STANDALONE_SERVER){
				return "icon-hv-host";
			}else if(t === INVENTORY_ID_VMWARE_RESOURCE_POOL){
				return "icon-hv-resource_pool";
			}else if(t === INVENTORY_ID_VMWARE_V_APP){
				return "icon-hv-vapp";
			}else if(t === INVENTORY_ID_VMWARE_TEMPLATE || t === INVENTORY_ID_XEN_CUSTOM_TEMPLATE){
				return "icon-hv-template";
			}else if(t === INVENTORY_ID_VMWARE_VM_DISK || t === INVENTORY_ID_XEN_VM_DISK){
				return "icon-hv-drive";
			}else if(t === INVENTORY_ID_SYSTEM) {
				return "icon-uui-unitrends-appliance2";
			} else {
				return "icon-hv-folder";
			}
		};

    	var isValidNodeForNodeType =function filterNode(treeNode,nodeType){

    		if(treeNode.type_family === INVENTORY_TYPE_FAMILY_SYSTEM){
    			return true;
    		}
    		switch (nodeType) {
			    case INVENTORY_TYPE_FAMILY_CLIENT:
		    		if(treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
						return true;
					}
			    	return false;
			    case INVENTORY_TYPE_FAMILY_CLIENT_NAS:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
			    			if(treeNode.name.indexOf("-NAS-RRC")>-1){
                    			return true;
                			}
                		}
			    	return false;	
			    case INVENTORY_TYPE_FAMILY_HYPER_V:
		    		if(treeNode.type_family === INVENTORY_TYPE_FAMILY_HYPER_V || treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
						return true;
					}	
			        return false;
			    case INVENTORY_TYPE_FAMILY_VMWARE:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_VMWARE){
						return true;
					}
			        return false;
			    case INVENTORY_TYPE_FAMILY_XEN:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_XEN){
						return true;
					}
			        return false;    
			    case INVENTORY_TYPE_FAMILY_EXCHANGE:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_EXCHANGE || treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
						return true;
					}	
			        return false;
			    case INVENTORY_TYPE_FAMILY_ORACLE:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_ORACLE || treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
						return true;
					}	
			        return false;
			    case INVENTORY_TYPE_FAMILY_SQL:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_SQL || treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
						return true;
					}	
			        return false;
			    case INVENTORY_TYPE_FAMILY_SHAREPOINT:
			    	if(treeNode.type_family === INVENTORY_TYPE_FAMILY_SHAREPOINT || treeNode.type_family === INVENTORY_TYPE_FAMILY_CLIENT){
						return true;
					}	
			        return false;
			}

    		return true;
    	}

    	var isNodeEnableForNodeType =function filterNode(treeNode,nodeType){

    		switch (nodeType) {
			    case INVENTORY_TYPE_FAMILY_CLIENT:
		    		if(treeNode.type === INVENTORY_ID_CLIENT_AIX || treeNode.type === INVENTORY_ID_CLIENT_DOS
		    			||treeNode.type === INVENTORY_ID_CLIENT_FREE_BSD || treeNode.type === INVENTORY_ID_CLIENT_HPUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_I_SERIES || treeNode.type === INVENTORY_ID_CLIENT_LINUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_MAC || treeNode.type === INVENTORY_ID_CLIENT_NETWARE
		    			||treeNode.type === INVENTORY_ID_CLIENT_OES || treeNode.type === INVENTORY_ID_CLIENT_OS2
		    			||treeNode.type === INVENTORY_ID_CLIENT_SGI || treeNode.type === INVENTORY_ID_CLIENT_SCO
		    			||treeNode.type === INVENTORY_ID_CLIENT_SOLARIS || treeNode.type === INVENTORY_ID_CLIENT_UNIX
		    			||treeNode.type === INVENTORY_ID_CLIENT_WINDOWS || treeNode.type === INVENTORY_ID_CLIENT_OTHER
		    			){
						return true;
					}
		    	
			    	return false;
			    case INVENTORY_TYPE_FAMILY_CLIENT_NAS:
			    	if(treeNode.type === INVENTORY_ID_CLIENT_AIX || treeNode.type === INVENTORY_ID_CLIENT_DOS
		    			||treeNode.type === INVENTORY_ID_CLIENT_FREE_BSD || treeNode.type === INVENTORY_ID_CLIENT_HPUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_I_SERIES || treeNode.type === INVENTORY_ID_CLIENT_LINUX
		    			||treeNode.type === INVENTORY_ID_CLIENT_MAC || treeNode.type === INVENTORY_ID_CLIENT_NETWARE
		    			||treeNode.type === INVENTORY_ID_CLIENT_OES || treeNode.type === INVENTORY_ID_CLIENT_OS2
		    			||treeNode.type === INVENTORY_ID_CLIENT_SGI || treeNode.type === INVENTORY_ID_CLIENT_SCO
		    			||treeNode.type === INVENTORY_ID_CLIENT_SOLARIS || treeNode.type === INVENTORY_ID_CLIENT_UNIX
		    			||treeNode.type === INVENTORY_ID_CLIENT_WINDOWS || treeNode.type === INVENTORY_ID_CLIENT_OTHER
		    			){

			    			if(treeNode.name.indexOf("-NAS-RRC")>-1){
                    			return true;
                			}
                		}
		    	
			    	return false;
			    case INVENTORY_TYPE_FAMILY_HYPER_V:
		    		if(treeNode.type === INVENTORY_ID_HYPER_V_VM ){
						return true;
					}	
			        return false;
				case INVENTORY_TYPE_FAMILY_VMWARE:
			    	if(treeNode.type === INVENTORY_ID_VMWARE_VM || treeNode.type === INVENTORY_ID_VMWARE_TEMPLATE ) {
						return true;
					}
					// handle regex.
					if (treeNode.type === INVENTORY_ID_VMWARE_ESX_SERVER) {
						return true;
					}
			        return false;
			    case INVENTORY_TYPE_FAMILY_XEN:
			    	if(treeNode.type === INVENTORY_ID_XEN_VM || treeNode.type === INVENTORY_ID_XEN_CUSTOM_TEMPLATE){
						return true;
					}
			        return false;    
			    case INVENTORY_TYPE_FAMILY_EXCHANGE:
			    	if(treeNode.type === INVENTORY_ID_EXCHANGE_DATABASE ){
						return true;
					}
			        return false;
			    case INVENTORY_TYPE_FAMILY_ORACLE:
			    	if(treeNode.type === INVENTORY_ID_ORACLE_DATABASE ){
						return true;
					}
			        return false;
			    case INVENTORY_TYPE_FAMILY_SQL:
			    	if(treeNode.type === INVENTORY_ID_SQL_DATABASE ){
						return true;
					}	
			        return false;
			    case INVENTORY_TYPE_FAMILY_SHAREPOINT:
			    	if(treeNode.type === INVENTORY_ID_SHAREPOINT_FARM ){
						return true;
					}	
			        return false;
			}


    		return true;
    	} 
    	var recurFunc =function getRecursivelyTreeData(data,nodeType){

    		var isDisabled =true;
			 for(var j = 0; j< data.nodes.length;j++){
			 		
			 		isDisabled = !isNodeEnableForNodeType(data.nodes[j],nodeType);
			 		if(!isValidNodeForNodeType(data.nodes[j],nodeType)){
			 			continue;
			 		}
					var nodeIcon = iconFunc(data.nodes[j].type)+" icon"; 	
					rootNodeObj={id:data.nodes[j].id,parent:data.id,text:data.nodes[j].name,
						icon:nodeIcon,state: { opened: false,disabled: isDisabled},data:{expanded:false,type:data.nodes[j].type}};
					rootNodeArray.push(rootNodeObj);
					if(data.nodes[j].nodes instanceof Array){
					   getRecursivelyTreeData(data.nodes[j],nodeType);
					}
              }
			
			  
		};

        this.loadTreeData = function($http,$scope,$rootScope,nodeType,isEdit,jobId){
        	$rootScope.treeData =[];
            finalTreeDataArray = [];
			rootNodeArray = [];
            
			for(var k=0;k<$rootScope.treeDataCache.length;k++){   

				var nodeIcon = iconFunc($rootScope.treeDataCache[k].type)+" icon"; 	
				rootNodeObj={id:$rootScope.treeDataCache[k].id,parent:"#",text:$rootScope.treeDataCache[k].name,
				icon:nodeIcon,state: { opened: true,disabled: true},data:{expanded:true,type:$rootScope.treeDataCache[k].type}};
				rootNodeArray.push(rootNodeObj);
				var isDisabled = true;
				var jsonTreeData = $rootScope.treeDataCache[k].nodes;

				var jsonData = this.getSortedJson(jsonTreeData,"name");
			
				for(var i = 0; i< jsonData.length;i++){
					isDisabled = !isNodeEnableForNodeType(jsonData[i],nodeType);
			 		if(!isValidNodeForNodeType(jsonData[i],nodeType)){
			 			continue;
			 		}
					nodeIcon = iconFunc(jsonData[i].type)+" icon"; 	
					rootNodeObj={id:jsonData[i].id,parent:$rootScope.treeDataCache[k].id,text:jsonData[i].name,
					icon:nodeIcon,state: { opened: false,disabled: isDisabled},data:{expanded:false,type:jsonData[i].type}};
					rootNodeArray.push(rootNodeObj);
					  
					if(jsonData[i].nodes instanceof Array){
						recurFunc(jsonData[i],nodeType);
					}
				}
		 	}
			  finalTreeDataArray = rootNodeArray;
			  $rootScope.treeData = finalTreeDataArray;
                if(!isEdit){
					var nodeTree =$('#jstreeDivId').jstree(true);
					if (nodeTree.settings != undefined && nodeTree.settings.core !== undefined) {
						nodeTree.settings.core.data=$rootScope.treeData;
					}
					if (nodeTree.refresh !== undefined) {
						nodeTree.refresh();
					}
                }
           
              
              
        };

		this.getSortedJson = function(jsonData,key){
			jsonData.sort(function(a, b) {
				a = a[key].toLowerCase();
				b = b[key].toLowerCase();
				return (a < b) ? -1 : (a > b) ? 1 : 0;
			});
			return jsonData
		};

		this.openBackupDialog = function($http,$scope,$rootScope,ngDialog,isEdit,jobId,preSelect){
         var self = this;
			$scope.title = isEdit?"Edit Backup Job":"Create Backup Job";
	   		$scope.isEdit = isEdit;
            $scope.preSelect =(preSelect == true)?true :false;
	   		$scope.jobId = jobId;
        	$rootScope.treeData =[];

		    $http({
				method: 'get',
				url : '/api/inventory'
			}).success(function(data, status, headers){
				//$scope.backupDialogType = nodeType;
                $rootScope.treeDataCache=data.inventory;    
                /*if(isEdit){
                    self.loadTreeData($http,$scope,$rootScope,nodeType,isEdit,jobId);
                }*/
                /*check for screen height*/
                var setTopvalue='top:0%;'
                if (screen.height >1024){
                    setTopvalue='top:10%;'
                }else if(screen.height == 1024){
                    setTopvalue='top:6%;'
                }
				ngDialog.open({
                            /*template: 'app/protect/backup-physical/backupPhysical.html',*/
                            template: 'app/protect/backup-job/backupJob.html',
                            scope: $scope,
                            overlay:true,
                            modelDialogId:'backup-physical-dailog',
							ngDialogPostionStyle:setTopvalue,
							ngDialogStyle:'width:1100px;height:780px;',
                            preCloseCallback: function (value) {}
            });
          
            /*
			finalTreeDataArray = [];
			rootNodeArray = [];
            
			for(var k=0;k<data.inventory.length;k++){   

				var nodeIcon = iconFunc(data.inventory[k].type)+" icon"; 	
				rootNodeObj={id:data.inventory[k].id,parent:"#",text:data.inventory[k].name,
				icon:nodeIcon,state: { opened: true,disabled: true},data:{expanded:true,type:data.inventory[k].type}};
				rootNodeArray.push(rootNodeObj);
				
				var jsonData = data.inventory[k].nodes;
				for(var i = 0; i< jsonData.length;i++){
					if(nodeType === "NAS"){
						if(jsonData[i].name.indexOf("NAS-RRC") === -1){
							continue;	
						}

					} else if(nodeType === "PHYSICALSERVER"){
						if(jsonData[i].type != 17 || jsonData[i].name.indexOf("NAS-RRC") > -1){
							continue;
						}

				}
				 nodeIcon = iconFunc(jsonData[i].type)+" icon"; 	
				 rootNodeObj={id:jsonData[i].id,parent:data.inventory[k].id,text:jsonData[i].name,
				 icon:nodeIcon,state: { opened: false},data:{expanded:false,type:jsonData[i].type}};
				 rootNodeArray.push(rootNodeObj);
							  
				 if(jsonData[i].nodes instanceof Array){
					   recurFunc(jsonData[i],nodeType);
				  }
				}
		 	}
			  finalTreeDataArray = rootNodeArray;
			  $rootScope.treeData = finalTreeDataArray;
			  console.log($rootScope.treeData);*/
        	}).error(function(response) { });

	   };
	})

    .controller('ProtectCtrl', ['$scope', '$rootScope', '$http', 'Page','$compile', '$analytics','ngDialog', 'wizardService', '$protectService','inventorysvc',function($scope, $rootScope, $http, Page, $compile, $analytics,ngDialog,wizardService,$protectService,inventorysvc) {
        Page.setTitle('Protect');

        $scope.$on('$viewContentLoaded', function() {
            processProtectPage(PHD, window, $scope, $rootScope, $compile, $analytics);
        });

        $scope.loadStatus = function(sid, bid, date, name, type) {
            $(".job-inventory-result").hide();

            PHD.appliance_sid = sid;
            if (type == 'Backups') {
                console.log("in load backup detail status");
                backup_ids = bid;
                PHD.wizard("app/inventory/details/status.html", "view-status", {
                    title: gettext(name + " Backup Status: " + date),
                    dialogClass: "standalone",
                    height: 500,
                    helpArticle: PHD.App.getHelpLink("backup", true)
                });
            } else {
                console.log("in load backup copy detail status");
                copy_ids = bid;
                PHD.wizard("app/inventory/backup-copy-details/status.html", "view-status", {
                    title: gettext(name + " Backup Copy Status: " + date),
                    dialogClass: "standalone",
                    height: 390,
                    helpArticle: PHD.App.getHelpLink("backup", true)
                });
            }
        }
	/*******************On clcik of backup physical button open dialog with job wizard*****************/
		   var rootNodeObj={};
	       var rootNodeArray=[];
		   var finalTreeDataArray = [];

		$scope.openNASDialog = function(){
			$protectService.openBackupDialog($http,$scope,$rootScope,ngDialog,false);
        }
		
	    $scope.openBackupPhysicalDialog = function(){
	    	$protectService.openBackupDialog($http,$scope,$rootScope,ngDialog,false);
		}
	    $scope.openBackupJobDialog = function(){
            $scope.beforeOpenJobDialog();
            $protectService.openBackupDialog($http,$scope,$rootScope,ngDialog,false);   
            
        }
        
        $scope.beforeOpenJobDialog = function(){
            var assetType =INVENTORY_TYPE_FAMILY_CLIENT;
            $scope.selectedAssetType = assetType;
            $scope.selectedNodeList = [];
            console.log($scope.selectedNode);
            console.log(($scope.selectedNode !=""));
            if(typeof($scope.selectedNode) != 'undefined' && $scope.selectedNode !="\"\""){
                var selectedNodeArray=$scope.selectedNode.replace(/["]/g, "").split("&");
                for(var i =0; i< selectedNodeArray.length; i++){
                    var parsedNodeId = selectedNodeArray[i].replace('inventory=','');
                    var inventoryNodeObject = inventorysvc.nodeToObject(parsedNodeId);
                    var parsedAssetType = inventorysvc.getAssetType(parseInt(inventoryNodeObject.app_id));

                    if(i == 0){
                        $scope.selectedAssetType = parsedAssetType;
                        $scope.selectedNodeList.push(parsedNodeId);
                        continue;
                    }

                    if($scope.selectedAssetType === parsedAssetType){
                        $scope.selectedNodeList.push(parsedNodeId);
                    }
                }
        }
        
        }

	  
    }]);
