var irModule = angular.module('flrModule', ['ngDialog', 'angulartics', 'angulartics.google.analytics','ui.grid.selection']);

irModule.config(['ngDialogProvider', function (ngDialogProvider) {
    ngDialogProvider.setDefaults({
        plain: false,
        closeByDocument: true,
        closeByEscape: true,
        appendTo: false,
        preCloseCallback: function (value) {

        }
    });
}]);

irModule.factory('irFactory', function($http) {
    return {
        getIRDetail: function(method, url, sid,dataObj, type, hypervisor) {
            var params = {};
            if (sid != 0) {
                params.sid = sid;
                
                if(type !== "" ){
                    params.type = type;
                }
            }
            var promise = $http({
                url: url,
                data: dataObj,
                method: method,
                params: params
            }).success(function(data, status, headers){
                
            }).error(function(response){
                ngDialog.open({
                    dialogType:'error',
                    dialogMessage:response.result[0].message
                });
             
            });
            return promise;
        }
    };
});
		
irModule.controller('flrController', ['$scope', '$rootScope', '$http', 'ngDialog', 'wizardService', '$analytics', 'irFactory', function($scope, $rootScope, $http, ngDialog, wizardService, $analytics, irFactory ) {
    
    $scope.vfcDetails = {
        virtualClientMemory:0,
        virtualClientProcessor:0
            
    };
    $scope.isNewBackups = false;
    $scope.isNewBackupsDisabled = false;

    $scope.isNewBackupsHidden = liveTime !== "";
   /* var min_memory = 1,
        max_memory = 99999,
        memory_step = 1,
        min_processors = 1,
        max_processors = 99;
    if (hypervisorType === HYPERVISOR_VMWARE_HOST) {
        min_memory = 1024;
        memory_step = 4;
		$("#ir-edit-processor").spinner({min: min_processors, max: max_processors});
    	$("#ir-edit-memory").spinner({min: min_memory, max: max_memory, step: memory_step});
		 $scope.min_processors = min_processors;
		 $scope.max_processors =max_processors;
		 $scope.min_memory=min_memory;
		 $scope.max_memory=max_memory;
	  	
    } else if (hypervisorType === HYPERVISOR_HYPERV_HOST) {
        min_memory = 1024;
        memory_step = 2;
		$("#ir-edit-processor").spinner({min: min_processors, max: max_processors});
    	$("#ir-edit-memory").spinner({min: min_memory, max: max_memory, step: memory_step});
		 $scope.min_processors = min_processors;
		 $scope.max_processors =max_processors;
		 $scope.min_memory=min_memory;
		 $scope.max_memory=max_memory;
	  
    } else if (hypervisorType === HYPERVISOR_UNITRENDS_APPLIANCE) {
        max_processors = 4;
        max_memory = 8192;
        var params = {};
        params.sid = sid;
        $http({
            url: "/api/systems/details/",
            method: "get",
            params: params
        }).success(function (data) {
            max_processors = data.appliance.processors;
            var str_memory = data.appliance.memory.toString();
            str_memory.replace(" GB", "");
            max_memory = parseInt(str_memory, 10) * 1000;
			$("#ir-edit-processor").spinner({min: min_processors, max: max_processors});
    		$("#ir-edit-memory").spinner({min: min_memory, max: max_memory, step: memory_step});
			 $scope.min_processors = min_processors;
			 $scope.max_processors =max_processors;
			 $scope.min_memory=min_memory;
			 $scope.max_memory=max_memory;
	
        })
    }
	
     $scope.min_processors = min_processors;
	 $scope.max_processors =max_processors;
	 $scope.min_memory=min_memory;
	 $scope.max_memory=max_memory;*/
	
    var virtualStateURL = "/api/virtual_clients/"+virtualId+"/state/";
        irFactory.getIRDetail('get',virtualStateURL,sid,"","","").then(function(data){
        $scope.isNewBackupsDisabled = data.data.disabled;
        if($scope.isNewBackupsDisabled){
            $("#newBackupCheckId").removeAttr("disabled ");
        }else if(!$scope.isNewBackupsDisabled){
            $("#newBackupCheckId").removeAttr("disabled");
            $scope.isNewBackups = true;
        }

    });// End

    var virtualDetailsURL = "/api/virtual_clients/"+virtualId+"/details/";
    irFactory.getIRDetail('get',virtualDetailsURL,sid,"",virtualType,"").then(function(data){
        $scope.vfcDetails.virtualClientMemory = data.data.virtual_client.memory;
        $scope.vfcDetails.virtualClientProcessor = data.data.virtual_client.processors;
		
		
		
		 var min_memory = 1,
        max_memory = 99999,
        memory_step = 1,
        min_processors = 1,
        max_processors = 99;
    if (hypervisorType === HYPERVISOR_VMWARE_HOST) {
        min_memory = 1024;
        memory_step = 4;
		$("#ir-edit-processor").spinner({min: min_processors, max: max_processors});
    	$("#ir-edit-memory").spinner({min: min_memory, max: max_memory, step: memory_step});
		 $scope.min_processors = min_processors;
		 $scope.max_processors =max_processors;
		 $scope.min_memory=min_memory;
		 $scope.max_memory=max_memory;
	  	
    } else if (hypervisorType === HYPERVISOR_HYPERV_HOST) {
        min_memory = 1024;
        memory_step = 2;
		$("#ir-edit-processor").spinner({min: min_processors, max: max_processors});
    	$("#ir-edit-memory").spinner({min: min_memory, max: max_memory, step: memory_step});
		 $scope.min_processors = min_processors;
		 $scope.max_processors =max_processors;
		 $scope.min_memory=min_memory;
		 $scope.max_memory=max_memory;
	  
    } else if (hypervisorType === HYPERVISOR_UNITRENDS_APPLIANCE) {
        max_processors = 4;
        max_memory = 8192;
        var params = {};
        params.sid = sid;
        $http({
            url: "/api/systems/details/",
            method: "get",
            params: params
        }).success(function (data) {
            max_processors = data.appliance.processors;
            var str_memory = data.appliance.memory.toString();
            str_memory.replace(" GB", "");
            max_memory = parseInt(str_memory, 10) * 1000;
			$("#ir-edit-processor").spinner({min: min_processors, max: max_processors});
    		$("#ir-edit-memory").spinner({min: min_memory, max: max_memory, step: memory_step});
			 $scope.min_processors = min_processors;
			 $scope.max_processors =max_processors;
			 $scope.min_memory=min_memory;
			 $scope.max_memory=max_memory;
	
        })
    }
	
     $scope.min_processors = min_processors;
	 $scope.max_processors =max_processors;
	 $scope.min_memory=min_memory;
	 $scope.max_memory=max_memory;
   });// End
    
    $scope.newBackupChange = function(isNewBackupChanged){
        $scope.isNewBackups = isNewBackupChanged;
    };
    $scope.startStopBackups = function(){
        $scope.urlStartStop="";
        
        if($scope.isNewBackups){
            $scope.urlStartStop = "/api/virtual_clients/restores/start/"+virtualId+"/"
        }else if(!$scope.isNewBackups){
            $scope.urlStartStop = "/api/virtual_clients/restores/stop/"+virtualId+"/";
        }
        irFactory.getIRDetail('put',$scope.urlStartStop,sid,"","","").then(function(data){
        });  
    };

    $scope.virtualClientDetails = {client:{}};
    var parameters={};

    $scope.saveVirtualClientDetails = function(){
	
	     var processor = $( "#ir-edit-processor" ).val();
		 var memory = $("#ir-edit-memory").val();
		
		 $scope.vfcDetails.virtualClientProcessor = processor;
		 $scope.vfcDetails.virtualClientMemory = memory;
		 $scope.processorValidFlag = false;
		 $scope.memoryValidFlag = false;
		 $scope.checkMemoryStepFlag = false;
		 $scope.memoryStep = 1;
		  
		 if (hypervisorType === HYPERVISOR_VMWARE_HOST) {
             $scope.memoryStep = 4;
		 }else if (hypervisorType === HYPERVISOR_HYPERV_HOST) {
             $scope.memoryStep = 2;
		 }
		
		
		 if(processor < $scope.min_processors || processor > $scope.max_processors){
			  $scope.processorValidFlag = true;
     	 }
		 if(memory < $scope.min_memory || memory > $scope.max_memory){
			  $scope.memoryValidFlag =true;
		 }
		 if(memory % $scope.memoryStep !== 0){
			$scope.checkMemoryStepFlag =true;
		 }
		
		if($scope.processorValidFlag || $scope.memoryValidFlag || $scope.checkMemoryStepFlag){
    		return;
		}
		
        $scope.virtualClientDetails.client.processors = $scope.vfcDetails.virtualClientProcessor;
        $scope.virtualClientDetails.client.memory = $scope.vfcDetails.virtualClientMemory;
        //$scope.virtualClientDetails.client.audit_verify = 0;
        
        var clientDetailURL = "/api/virtual_clients/"+virtualId+"/";
      
        parameters.sid = sid;
        $http({
            method: 'PUT',
            params:parameters,
            url :clientDetailURL,
            data: JSON.stringify($scope.virtualClientDetails)
        }).success(function(data, status, headers){
               $scope.startStopBackups();
               ngDialog.open({
                   dialogType:'Information',
                   dialogMessage:"Successfully Updated"
               })

        }).error(function(response) {
               ngDialog.open({
                   dialogType:'retry',
                   modelDialogId:'irEditDialog',
                   dialogMessage:response.result[0].message
               })
        });
    }
	
}]);//end of controller