var recover = angular.module('recover', ['angulartics', 'angulartics.google.analytics','ngDialog','flrModule']);

/*
 * Controller for the Recover page.
*/

recover.controller('RecoverCtrl', ['$scope', '$rootScope', '$window', '$http', '$timeout', 'Page', '$analytics', 'ngDialog','wizardService', function($scope, $rootScope, $window, $http,$timeout, Page, $analytics, ngDialog, wizardService) {

		Page.setTitle('Recover');
        $scope.flr_flag = "BackupCopy";

        $scope.filterLoaded = function() {
            var PHD = window.PHD;

            // clean up filter.
            var $footer = $("#recovery-backup-footer");
            var replace = $footer.html().replace(/filter_namespace/g, "recover");
            $footer.html(replace);

            // wrap existing jQuery in functions and run after the filter (ng-include) is loaded.
            processBackupFilter(PHD, window);

            // The main recover page functions must load after the filter.
            processRecoverPage(PHD, window, $rootScope, $analytics);
			
		/*******************On click of Window Instant Recovery button open dialog with job wizard*****************/
			$scope.openWindowRecoverDialog = function(){
				ngDialog.open({
								template: 'app/recover/wir/windowRecoveryWizard.html',
								scope: $scope,
								overlay:true,
								modelDialogId:'window-instant-recover-dialog',
								ngDialogStyle:'width:82em; height:60em;  top: -150px;left: 80px;'
				});
		    };
            /*On click of Show Details open dialog*/
            $scope.openSearchFLRDialog = function() {
                  console.log('openSearchFLRDialog');
		          ngDialog.open({
                        template: 'app/recover/filerecovery/searchFLR/searchFLR.html',
                        scope: $scope,
                        overlay:true,
                        modelDialogId:'flr-search-dialog',
                        ngDialogPostionStyle:'top:10%;',
						ngDialogStyle:'width:1100px;height:780px;',
                 });
               
            };
            /* On click of Recover button open dialog */
            $scope.openRecoverDialog = function() {
		        isIRJob = false;
                if (!$('#restoreBtn').hasClass("disabled")) {
                    ngDialog.open({
                        template: 'app/recover/recoveryWizard.html',
                        scope: $scope,
                        overlay:true,
                        modelDialogId:'recover-dialog',
                        ngDialogStyle:(app_type === APPLICATION_TYPE_NAME_SHAREPOINT || app_type === APPLICATION_TYPE_NAME_ORACLE) ?'width:100em;top: -140px;left: 80px;' :'width:120em;top: -150px;left: 80px;'
                    });
                }
            };

            /* On click of VM Instant Recovery button open dialog */
            $scope.openIRDialog = function() {
                isIRJob = true;
                if (!$('#irBtn').hasClass("disabled") && !$('#vmIRBtn').hasClass("disabled")) {
                    ngDialog.open({
                        template: 'app/recover/recoveryWizard.html',
                        scope: $scope,
                        overlay: true,
                        modelDialogId: 'recover-dialog',
                        ngDialogStyle: 'width:120em; height:65em;  top: -150px;left: 80px;'
                    });
                }
            }

        };
        
        // Edit WIR
        $scope.openEditDialog = function(){
			$scope.vmName = vmName;
            if (!$('#editIRBtn').hasClass("disabled")) {
                ngDialog.open({
                    template: 'app/recover/ir/ir-edit-dialog/ir-edit-dialog.html',
                    scope: $scope,
                    overlay: true,
                    modelDialogId: 'irEditDialog',
                    ngDialogStyle: 'width:46em; height:30em;  top: -90px;left: 27px;'
                });
            }
        };
		
        /* On click of 'Recover Files' button to open Create file-level recovery job dialog */
        $scope.openFileLevelRecoveryJobDialogClick = function() {
             if((selectedBackup.backup_id != undefined) && (selectedBackup.backup_id != null) && (selectedBackup.backup_id != "")){
                 $scope.flr_flag = "Backup";
                 $scope.FLRBackup();
             }else if((selectedBackup.archive_id != undefined) && (selectedBackup.archive_id != null) && (selectedBackup.archive_id != "")){
                $scope.flr_flag = "BackupCopy";
                $scope.FLRBackupCopy();
            }
        };
    
        /* Call function if FLR for backup */
        $scope.FLRBackup=function(){
            if (!$('#restoreBtn').hasClass("disabled")) {
                if ((app_type != undefined) && (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER)) {
                    ngDialog.open({
                        template: 'app/recover/filerecovery/fileLevelRecoveryJobWizard.html',
                        scope: $scope,
                        overlay: true,
                        modelDialogId: 'create-filelevel-recovery-dialog',
                        ngDialogStyle: 'width:120em; height:70em;  top: -150px;left: 80px;'
                    });
                } else {
                    ngDialog.open({
                        dialogType: 'Confirmation',
                        dialogMessage: "Do you want to create the file recovery object?",
                        scope: this,
                        overlay: true,
                        modelDialogId: 'fileRecoveryPostApiConfirmationDialog',
                        onConfirmOkButtonClick: 'fileRecoveryPostApiCall()'
                    });
                }
            }
        };
    
        $scope.FLRBackupCopy=function(){
            if (!$('#restoreBtn').hasClass("disabled")) {
                 ngDialog.open({
                    template: 'app/recover/filerecovery/fileLevelRecoveryJobWizard.html',
                    scope: $scope,
                    overlay: true,
                    modelDialogId: 'create-filelevel-recovery-dialog-backupcopy',
                    ngDialogStyle: 'width:120em; height:70em;  top: -150px;left: 80px;'
                });
                
                /*if ((app_type != undefined) && (app_type === APPLICATION_TYPE_NAME_PHYSICAL_SERVER)) {
                    ngDialog.open({
                        template: 'app/recover/filerecovery/fileLevelRecoveryJobWizard.html',
                        scope: $scope,
                        overlay: true,
                        modelDialogId: 'create-filelevel-recovery-dialog-backupcopy',
                        ngDialogStyle: 'width:120em; height:70em;  top: -150px;left: 80px;'
                    });
                } else {
                    ngDialog.open({
                        dialogType: 'Confirmation',
                        dialogMessage: "Do you want to create the file recovery object?",
                        scope: this,
                        overlay: true,
                        modelDialogId: 'fileRecoveryPostApiConfirmationDialog-backupcopy',
                        onConfirmOkButtonClick: 'fileRecoveryPostApiCall()'
                    });
                }*/
            }
        };
    
    
        $scope.fileRecoveryPostApiCall=function(){
            var load = PHD.showLoadingIndicator("body", true, "Starting File Level Recovery...");
            var restoreObj= {};
            var sid = (PHD.appliance_sid === null) ? "" : "?sid=" + ((selectedBackup.replicated == 'true') ? selectedBackup.local_system_id : selectedBackup.sid);
            var url = "/api/restore/files/" + sid;

            restoreObj.backup_id = selectedBackup.backup_id;
            restoreObj = JSON.stringify(restoreObj);

            $http ({
                method: 'post',
                url : url,
                data: restoreObj
            }).success(function(data){
                PHD.hideLoadingIndicator(load);
                data = {};
                data.result = [{'message': 'File level recovery job successfully started.'}];
                var options = {};
                
                if (window.location.href.indexOf("#/protect") !== -1 || window.location.href.indexOf("#/jobs") !== -1) {
                    options.buttons = [
                        {
                            text: gettext("View FLR"),
                            click: function () {
                                window.location.href = "#/recover/#1";
                                $(this).dialog("destroy").remove();
                            }
                        }
                    ];
                }

                PHD.throwNotice(data, options);
                ngDialog.close('fileRecoveryPostApiConfirmationDialog');
                
            }).error(function(response) {
                PHD.hideLoadingIndicator(load);
                ngDialog.open({
                    dialogType:'retry',
                    dialogMessage:response.result[0].message
                })
            });
        }
		
		/*********************************Delete WIR row **************************************/
		 $scope.wirDeleteRadioSelection ="2";
	 
	     $scope.openIRDeleteDialog = function(){
             if (!$('#tearDownBtnId').hasClass("disabled")) {
                 if (jobType != "wir") {
                     ngDialog.open({
                         template: 'app/recover/ir/ir-delete-dialog/ir-delete-dialog.html',
                         scope: $scope,
                         overlay: true,
                         modelDialogId: 'deleteExistinIRConfirmation',
                         ngDialogStyle: 'width:44em; height:20em;  top: -90px;left: 27px;right: 27px;'
                     });
                 } else {
                     if (hypervisorType == "Unitrends appliance" || wirMode == "halted") {
                         ngDialog.open({
                             template: 'app/recover/ir/ir-delete-dialog/wir-delete-haltedmode-dialog.html',
                             scope: $scope,
                             overlay: true,
                             modelDialogId: 'deleteIRConfirmation',
                             ngDialogStyle: 'width:45em; height:18em;  top: -90px;left: 27px;right: 27px;'
                         });

                     } else {
                         ngDialog.open({
                             template: 'app/recover/ir/ir-delete-dialog/wir-delete-dialog.html',
                             scope: $scope,
                             overlay: true,
                             modelDialogId: 'deleteIRRow',
                             showHelpArticleButton: true,
                             ngDialogStyle: 'width:46em; height:30em;  top: -90px;left: 27px;right: 27px;'
                         });
                     }
                 }
             }
         };
 
		$scope.onConfirmWIRDelete = function(deleteFromHypervisorFlag) {
			
		    var irdeleteRadioVal =  $("input[name='irDeleteRadioBtn']:checked").val();
         	var url = "/api/virtual_clients/"+virtual_id+"/";
			var params = {};
			var deleteObj={};
            if(jobType != "wir"){ 
                     params.sid = sid;
				     deleteObj.type= jobType;
     	    }else{
                 if(hypervisorType == HYPERVISOR_UNITRENDS_APPLIANCE || wirMode == MODE_HALTED ){
                     params.sid =sid;
                     deleteObj.type= jobType;
                     deleteObj.deleteFromHypervisor= deleteFromHypervisorFlag;  
                 }else{
                     if(irdeleteRadioVal == 1){
                       deleteObj.deleteFromHypervisor= 1;    
                         
                     }else{
                       deleteObj.deleteFromHypervisor= 0;    
                     }
                     params.sid =sid;
                     deleteObj.type= jobType;
                     
                 }
            }
			
            $http({
                method:'delete',
                url:url,
				data:JSON.stringify(deleteObj),
                params:params
            }).success(function(data, status, headers){
			   ngDialog.close('deleteIRConfirmation');
			   ngDialog.close('deleteIRRow');
			   ngDialog.close('deleteExistingIRConfirmation');  
                $timeout(function() {
                    
                    $rootScope.RecoverTimer.stop();
                    $(document).off("timertick.recoverpage");
                    delete $(document);
                    
                    var eventsTab = angular.element(document.getElementById("recover-ir"));
                    var injector = eventsTab.injector();
                    var route = injector.get('$route');
                    route.reload();
                }, 500);
                
		    }).error(function(response) { 
                 ngDialog.open({
                 dialogType:'retry',
                 modelDialogId:'replication-dailog',
                 dialogMessage:response.result[0].message
                })
            });
			
		};

	}]
);

