var TreeViewData, nodeTmpl, headerTmpl, childTmpl, 
    checkboxes = true,
    output = "",
    INV_TYPE_UNIVERSE           = 8,
    INV_TYPE_LOOKUP = {};


// Inventory ID - System Nodes
var INVENTORY_ID_SYSTEM = 1001;

// Inventory ID - Client Nodes
var INVENTORY_ID_CLIENT_AIX       = 2001;
var INVENTORY_ID_CLIENT_DOS       = 2002;
var INVENTORY_ID_CLIENT_FREE_BSD  = 2003;
var INVENTORY_ID_CLIENT_HPUX      = 2004;
var INVENTORY_ID_CLIENT_I_SERIES  = 2005;
var INVENTORY_ID_CLIENT_LINUX     = 2006;
var INVENTORY_ID_CLIENT_MAC       = 2007;
var INVENTORY_ID_CLIENT_NETWARE   = 2008;
var INVENTORY_ID_CLIENT_OES       = 2009;
var INVENTORY_ID_CLIENT_OS2       = 2010;
var INVENTORY_ID_CLIENT_SGI       = 2011;
var INVENTORY_ID_CLIENT_SCO       = 2012;
var INVENTORY_ID_CLIENT_SOLARIS   = 2013;
var INVENTORY_ID_CLIENT_UNIX      = 2014;
var INVENTORY_ID_CLIENT_WINDOWS   = 2015;
var INVENTORY_ID_CLIENT_OTHER     = 2016;

// Inventory ID - Exchange Nodes
var INVENTORY_ID_EXCHANGE_APPLICATION     = 102001;
var INVENTORY_ID_EXCHANGE_DATABASE        = 102002;

// Inventory ID - Hyper-V Nodes
var INVENTORY_ID_HYPER_V_SERVER           = 201002;  //Application Node
var INVENTORY_ID_HYPER_V_VM               = 201003;

// Inventory ID - Oracle Nodes
var INVENTORY_ID_ORACLE_APPLICATION      = 104001;
var INVENTORY_ID_ORACLE_DATABASE         = 104002;

// Inventory ID - SharePoint Nodes
var INVENTORY_ID_SHAREPOINT_APPLICATION   = 105001;
var INVENTORY_ID_SHAREPOINT_FARM          = 105002;

// Inventory ID - SQL Nodes
var INVENTORY_ID_SQL_SERVER               = 106003; //Application Node
var INVENTORY_ID_SQL_DATABASE             = 106004;

// Inventory ID - VMware Nodes
var INVENTORY_ID_VMWARE_CLUSTER           = 202004;
var INVENTORY_ID_VMWARE_ESX_SERVER        = 202005;
var INVENTORY_ID_VMWARE_FOLDER            = 202006;
var INVENTORY_ID_VMWARE_RESOURCE_POOL     = 202007;
var INVENTORY_ID_VMWARE_V_APP             = 202008;
var INVENTORY_ID_VMWARE_VM                = 202009;
var INVENTORY_ID_VMWARE_TEMPLATE          = 202010;
var INVENTORY_ID_VMWARE_VM_DISK           = 202011;

//XEN
var INVENTORY_ID_XEN_POOL_MASTER          = 203001;
var INVENTORY_ID_XEN_STANDALONE_SERVER    = 203002;
var INVENTORY_ID_XEN_SERVER_IN_A_POOL     = 203003;
var INVENTORY_ID_XEN_VM                   = 203007;
var INVENTORY_ID_XEN_VM_DISK              = 203008;
var INVENTORY_ID_XEN_CUSTOM_TEMPLATE      = 203009;

// Inventory Type Family
var INVENTORY_TYPE_FAMILY_SYSTEM      = 1000;
var INVENTORY_TYPE_FAMILY_CLIENT      = 2000;
var INVENTORY_TYPE_FAMILY_EXCHANGE    = 102000;
var INVENTORY_TYPE_FAMILY_HYPER_V     = 201000;
var INVENTORY_TYPE_FAMILY_ORACLE      = 104000;
var INVENTORY_TYPE_FAMILY_SHAREPOINT  = 105000;
var INVENTORY_TYPE_FAMILY_SQL         = 106000;
var INVENTORY_TYPE_FAMILY_VMWARE      = 202000;
var INVENTORY_TYPE_FAMILY_XEN         = 203000;

    INV_TYPE_LOOKUP[INVENTORY_ID_SYSTEM] = ["icon-uui-unitrends-appliance2", "Appliance"];

    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_OTHER] = ["icon-uui-asset", "Compute Resource"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_WINDOWS] = ["icon-uui-asset", "Windows"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_LINUX] = ["icon-uui-asset", "Linux"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_AIX] = ["icon-uui-asset", "AIX"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_DOS] = ["icon-uui-asset", "DOS"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_FREE_BSD] = ["icon-uui-asset", "Free BSD"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_HPUX] = ["icon-uui-asset", "HP/UX"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_I_SERIES] = ["icon-uui-asset", "iSeries"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_MAC] = ["icon-uui-asset", "Mac"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_NETWARE] = ["icon-uui-asset", "Netware"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_OES] = ["icon-uui-asset", "OES"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_OS2] = ["icon-uui-asset", "OS/2"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_SGI] = ["icon-uui-asset", "SGI"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_SCO] = ["icon-uui-asset", "SCO"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_SOLARIS] = ["icon-uui-asset", "Solaris"];
    INV_TYPE_LOOKUP[INVENTORY_ID_CLIENT_UNIX] = ["icon-uui-asset", "Unix"];

    INV_TYPE_LOOKUP[INVENTORY_ID_EXCHANGE_APPLICATION] = ["icon-uui-asset-exchange", "Exchange"];
    INV_TYPE_LOOKUP[INVENTORY_ID_EXCHANGE_DATABASE] = ["icon-database", "Database"];

    INV_TYPE_LOOKUP[INVENTORY_ID_HYPER_V_SERVER] = ["icon-uui-asset-hyperv", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_HYPER_V_VM] = ["icon-hv-vm", "Virtual Machine"];

    INV_TYPE_LOOKUP[INVENTORY_ID_SQL_SERVER] = ["icon-uui-asset-sql", "SQL Server"];
    INV_TYPE_LOOKUP[INVENTORY_ID_SQL_DATABASE] = ["icon-database", "Database"];

    INV_TYPE_LOOKUP[INVENTORY_ID_ORACLE_APPLICATION] = ["icon-uui-asset-oracle", "Oracle"];
    INV_TYPE_LOOKUP[INVENTORY_ID_ORACLE_DATABASE] = ["icon-database", "Database"];

    INV_TYPE_LOOKUP[INVENTORY_ID_SHAREPOINT_APPLICATION] = ["icon-uui-asset-sharepoint", "Sharepoint"];
    INV_TYPE_LOOKUP[INVENTORY_ID_SHAREPOINT_FARM] = ["icon-database", "Farm"];

    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_CLUSTER] = ["icon-hv-cluster", "Cluster"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_VM_DISK] = ["icon-hv-drive", "Disk"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_VM] = ["icon-hv-vm", "Virtual Machine"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_FOLDER] = ["icon-hv-folder", "Folder"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_RESOURCE_POOL] = ["icon-hv-resource_pool", "Resource Pool"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_V_APP] = ["icon-hv-vapp", "vApp"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_ESX_SERVER] = ["icon-hv-host", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_VMWARE_TEMPLATE] = ["icon-hv-template", "Template"];

    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_POOL_MASTER] = ["icon-hv-cluster", "Pool Master"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_VM_DISK] = ["icon-hv-drive", "Disk"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_VM] = ["icon-hv-vm", "Virtual Machine"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_STANDALONE_SERVER] = ["icon-hv-host", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_SERVER_IN_A_POOL] = ["icon-hv-host", "Host"];
    INV_TYPE_LOOKUP[INVENTORY_ID_XEN_CUSTOM_TEMPLATE] = ["icon-hv-template", "Template"];

    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_SYSTEM] = ["icon-uui-unitrends-appliance2", "Appliance"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_CLIENT] = ["icon-uui-asset", "Server"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_EXCHANGE] = ["icon-uui-asset-exchange", "Exchange"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_HYPER_V] = ["icon-uui-asset-hyperv", "Hyper-V"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_SHAREPOINT] = ["icon-uui-asset-sharepoint", "Sharepoint"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_SQL]= ["icon-uui-asset-sql", "SQL Server"];
    INV_TYPE_LOOKUP[INVENTORY_TYPE_FAMILY_VMWARE] = ["icon-uui-asset-vmware", "VMware"];
    INV_TYPE_LOOKUP[INV_TYPE_UNIVERSE] = ["icon-hv-universe", "Global"];

self.addEventListener('message', function(e) {
    importScripts('../../vendor/underscore/underscore-min.js');
    initTemplates();
    var root;
    // Morph the inventory based on how many nodes are returned.
    if (e.data.inventory != null && e.data.inventory.length > 0) {
        if (e.data.inventory.length == 1) {
            root = e.data.inventory[0];
        } else {
            root = { "type_family": 0, "id": "0_0", "name": "Global", "type": INV_TYPE_UNIVERSE, "nodes": e.data.inventory};
        }
    } else {
        root = { "type_family": 0, "id": "0_0", "name": "Empty", "type": INV_TYPE_UNIVERSE, "nodes": []};
    }

    TreeViewData = root;
    // driven by protect vs restore.  On protect, false.
    //checkboxes = e.data.inventory.checkboxes;
    checkboxes = e.data.checkboxes;
    output = render({ "node": TreeViewData, "children": (TreeViewData.nodes !== null) }, 0);
    self.postMessage({
        "html": output,
        "tree": TreeViewData
    });
}, false);

function render(item, depth, last, dots) {
    var html = "",
        last = (typeof last === 'undefined') ? true : last,
        dots = (typeof dots === 'undefined') ? [] : dots;

    //console.log("item = " + JSON.stringify(item));
    item.node.depth = depth;
    item.node.t = nodeType(item.node.type);
   // console.log("item.node.type = " + item.node.type);
    item.node.type = [item.node.type, INV_TYPE_LOOKUP[item.node.type][0], INV_TYPE_LOOKUP[item.node.type][1]];
    item.node.dots = dots;
    item.last = last;

    // Don't show checkbox on Universe node.
    item.checkboxes = (checkboxes && (item.node.type_family != 0));

    item.node.cache = "";

    item.node.cache += nodeTmpl(item.node);

    item.node.cache += headerTmpl(item);

    html += item.node.cache;

    if(item.node.nodes) {
        var childContainer = childTmpl({expand: (!depth)});
        html += childContainer;
        item.node.cache += (childContainer + "</div>");
        dots = buildDots(item, dots.slice(0,depth), depth);
        _.each(item.node.nodes, function(value, index, arr) {
            var last = (arr.length - index === 1);
            html += render({
                "node":value, 
                "children": (value.nodes !== null && value.nodes.length > 0),   // null or empty array means no children.
                "last": last
            }, depth+1, last, dots);
        });
        html += "</div>";
    }

    item.node.cache += "</div>";
    html += "</div>";
    return html;
}

function initTemplates() {
    // if the disk is excluded, start the display this way.
    nodeTmpl = _.template(
    '<div class="checkable<% if(!type_family) { %> tree-universe<% } else if (type[0] == INVENTORY_ID_VMWARE_VM_DISK && is_excluded) { %> expl-excluded<% } %>" data-dbid="<%= id %>" data-node="<%= t %>" data-type="<%= type[0] %>">'
    );

    headerTmpl = _.template(
        '<div class="header clearfix">' +
        '<% for(var i=0;i<(node.depth-1);i++) { %><i class="dots <%= node.dots[i] %>"></i><% } %>' +
        '   <% if (last && node.depth) { %><i class="dots last"></i><% } else if(node.depth) { %><i class="dots full"></i><% } %>' +
        '   <% if (children) { %><i class="expand-ctrl<% if(!node.depth){ %> expanded<% } %>"></i><% } else { %><i class="dots straight"></i><% } %>' +
        '   <% if (checkboxes) { %><i class="checkbox"></i><% } %>' +
        '   <% if (node.type[0] === 7) { %>' +
        '   <img src="assets/images/types/hvdark<%= node.family %>.png" alt="<%= node.type[2] %>" title="<%= node.type[2] %>" width="16" height="16">' +
        '   <% } else { %>' + 
        '   <i class="<%= node.type[1] %> icon" alt="<%= node.type[2] %>" title="<%= node.type[2] %>"></i>' +
        '   <% } %>' +
        '   <span class="item-name"><%= node.name %></span>' +
        '</div>'
        );

    childTmpl = _.template(
        '<div class="children<% if(expand) { %> open<% } %>">'
        );
}

function buildDots(parent, dots, depth) {
    if(dots.length < depth) {
        if(parent.last) {
            dots.push("no-fill");
        }
        else {
            dots.push("left");
        }
    }
    return dots;
}

function nodeType(t) {
    if(t === INVENTORY_ID_VMWARE_VM || t === INVENTORY_ID_VMWARE_TEMPLATE) {
        return "vm";
    } else if(t === INVENTORY_ID_VMWARE_VM_DISK) {
        return "disk";
    } else if (t >= INVENTORY_ID_CLIENT_AIX && t <= INVENTORY_ID_CLIENT_OTHER) {
        return "computer";
    } else {
        return "container";
    }
}
